#!/bin/bash

    PATH+=:/opt/android-sdk-21/tools

    echo "PACKAGE_NAME=$PACKAGE_NAME"
    echo "PACKAGE_VERSION=$PACKAGE_VERSION"
    versionCode=$(echo $PACKAGE_VERSION | sed 's@\.@@g' )
    export ANDROIDSDK="/opt/android-sdk-21"
    export ANDROIDNDK="/opt/android-ndk-r6"
    #xport ANDROIDNDKVER="r8c" 2do
    #xport ANDROIDAPI="10" #arm-linux-androideabi/src/org/libsdl/app/SDLActivity.java:1537: cannot find symbol -> 14
    export ANDROIDAPI="14" #android:minSdkVersion="10"

    screenOrientation="sensor"                  #landscape portrait
    noHistory="false"                           #true = crash @ Button.HOME
    configChanges="keyboardHidden|orientation"  #rotate ok

#AndroidManifest.xml 2do
    #<uses-permission android:name="android.permission.WAKE_LOCK" />
    #<uses-permission android:name="android.permission.CALL_PHONE" />
    cat > AndroidManifest.xml << EOF
<?xml version="1.0" encoding="utf-8"?>
<manifest xmlns:android="http://schemas.android.com/apk/res/android"
    package="at.blacknoise.$PACKAGE_NAME"
    android:versionCode="$versionCode"
    android:versionName="$PACKAGE_VERSION"
    android:installLocation="auto"
>

    <supports-screens
        android:smallScreens="true"
        android:normalScreens="true"
        android:largeScreens="true"
        android:anyDensity="true"
        android:xlargeScreens="true"
    />

    <application android:label="@string/appName"
        android:icon="@drawable/icon"
        android:allowBackup="true"
        android:theme="@android:style/Theme.NoTitleBar.Fullscreen"
        android:hardwareAccelerated="true"
    >


    <meta-data android:name="wakelock" android:value="0"/>

    <activity android:name="org.kivy.android.PythonActivity"
        android:label="@string/appName"


        android:screenOrientation="$screenOrientation"

        android:configChanges="$configChanges"

    >

        <intent-filter>
            <action android:name="android.intent.action.MAIN" />
            <category android:name="android.intent.category.LAUNCHER" />
        </intent-filter>
    </activity>

    <service android:name="org.kivy.android.PythonService"
        android:process=":PythonService"
    />

    </application>

    <uses-sdk android:minSdkVersion="10" android:targetSdkVersion="$ANDROIDAPI" />
    <uses-permission android:name="android.permission.WRITE_EXTERNAL_STORAGE" />
    <uses-permission android:name="android.permission.INTERNET" />
    <uses-feature android:glEsVersion="0x00020000" />

</manifest>
EOF

    android update project --target android-$ANDROIDAPI --path . || exit 1
    sed -i "s@PythonActivity@$PACKAGE_NAME-$PACKAGE_VERSION@g" build.xml
    exit 0
