#!/bin/bash

    PYTHON_KIVY="/opt/arm-linux-androideabi/python-2.7-kivy-1.10"

    #rm -rvf private #clean up
    mkdir -p                                                              "private/include/python2.7"         || exit 1
    cp -pPv    "$PYTHON_KIVY/python-install/include/python2.7/pyconfig.h" "private/include/python2.7"         || exit 1
    mkdir -p                                                              "private/lib/python2.7"             || exit 1
    rsync -avx "$PYTHON_KIVY/python-install/lib/python2.7/"               "private/lib/python2.7"             || exit 1

    mkdir -p                                                              "private/lib/python2.7/lib-dynload" || exit 1
    cp -pPv "$libbncsql/bin/libbncsql_py.so"                              "private/lib/python2.7/lib-dynload" || exit 1
    cp -pPv "$libbncsql/bin/libbnplugin_py.so"                            "private/lib/python2.7/lib-dynload" || exit 1

    mkdir -p                                                              "libs/armeabi"                      || exit 1
    cp -pPv "$libbncsql/bin/libbncsql.so"                                 "libs/armeabi"                      || exit 1
    cp -pPv  $libbncsql/bin/libbncsql-*.so                                "libs/armeabi"                      || exit 1
    cp -pPv  $PYTHON_KIVY/libs/armeabi/*                                  "libs/armeabi"                      || exit 1

    srcDir="../../python"
    for srcFile in `find $srcDir -name "*.pyo" | sed "s@$srcDir@@g" | sed 's@^/@@g'` ; do
	#echo $srcFile
	cp "$srcDir/$srcFile" "private/${srcFile}" || exit 1
    done
    for srcFile in `find $srcDir -name "*.kv" | sed "s@$srcDir@@g" | sed 's@^/@@g'` ; do
	#echo $srcFile
	cp "$srcDir/$srcFile" "private/${srcFile}" || exit 1
    done
    for srcFile in `find $srcDir -name "*.png" | sed "s@$srcDir@@g" | sed 's@^/@@g'` ; do
	#echo $srcFile
	cp "$srcDir/$srcFile" "private/${srcFile}" || exit 1
    done

    cp "../../LICENSE"           "private/LICENSE"         || exit 1
    cp "../../NOTICE"            "private/NOTICE"          || exit 1
    cp "../../LICENSE.EXT"       "private/LICENSE.EXT"     || exit 1
    cp "$srcDir/Demo_Solar.bncbin" "private/Demo_Solar.bncbin" || exit 1
    cp "$srcDir/Demo-SQL.bncsql"   "private/Demo-SQL.bncsql"   || exit 1
    echo "libbncsql=$libbncsql="
    cp "$libbncsql/bin/testbncsql.blacknoise.at.crt" "private/testbncsql.blacknoise.at.crt" || exit 1
    cp "$libbncsql/bin/testbncsql.blacknoise.at.key" "private/testbncsql.blacknoise.at.key" || exit 1

    mkdir -p  assets || exit 1
    tar -zcvf assets/private.mp3 -C private . || exit 1
