#!/bin/bash
#Version: 1.0.0

    echo "$0 Install -> 1=$1 2=$2 3=$3 4=$4"

    mkdir -p $4 || exit 1

# Create an initial disk image (200 megs)
    rm -f                                                      $4/myimg.dmg
    hdiutil create -size 200m -fs HFS+ -volname "bncsql-$2-$3" $4/myimg.dmg
# Mount the disk image
    hdiutil attach $4/myimg.dmg
# Install app
    cd $1/../.. || exit 1
    rsync -avx . "/Volumes/bncsql-$2-$3/" #bug2 chown root/root with sudo
    ls -l        "/Volumes/bncsql-$2-$3"
# Obtain device information
    DEVS=$(hdiutil attach $4/myimg.dmg | cut -f 1)
    DEV=$(echo $DEVS | cut -f 1 -d ' ')
    echo "DEV=$DEV="
# Unmount the disk image
    hdiutil detach $DEV
# Convert the disk image to read-only
    rm -f                                        $4/bncsql-$2-$3.dmg
    hdiutil convert $4/myimg.dmg -format UDZO -o $4/bncsql-$2-$3.dmg
    rm -f                                        $4/myimg.dmg
