#!/bin/bash
#Version: 1.0.1

    cd $(dirname $0)
    echo "$0 Install -> 1=$1 2=$2 3=$3 4=$4"

    rm -f *.exe
    install -pv bncsql.ico $1
    install -pv bncsql.png $1


function ServiceRmDir () {
    [ "x"  == "x$1" ] && return
    [ "x/" == "x$1" ] && return
    echo "ServiceRmDir -> $1"
    WinDir=$(echo $1 | sed 's@/@\\@g')
    UnDelete+="    RmDir  \"\$INSTDIR$WinDir\"
"
    ServiceRmDir "$(dirname $1)"
} #function ServiceRmDir ()


function ServiceDir () {
    echo "ServiceDir -> $1"
    WinDir=$(echo $1 | sed "s@$srcDir@@g" | sed 's@/@\\@g')
    InFile+="    CreateDirectory  \"\$INSTDIR$WinDir\"
"
    for xFile in $(find $1 -maxdepth 1 -type f) ; do
	echo "xFile=$xFile"
	WinFile=$(echo $xFile | sed "s@$srcDir@@g" | sed 's@/@\\@g')
	InFile+="    File      \"/oname=\$INSTDIR$WinFile\" \"$xFile\"
"
	UnDelete+="    Delete \"\$INSTDIR$WinFile\"
"
    done
    ServiceRmDir "$(echo $1 | sed "s@$srcDir@@g")"
} #function ServiceDir ()


    InFile=""
    UnDelete=""
    srcDir="$1"
IFS="
"
    for xDir in $(find $srcDir -type d | sort -r) ; do
	ServiceDir "$xDir"
	#break
    done
    #echo "InFile=$InFile="
    #echo "UnDelete=$UnDelete="

cat > bncsql.nsi << EOF
!include "MUI2.nsh"

!define MUI_ICON "bncsql.ico"
!define MUI_HEADERIMAGE
!define MUI_HEADERIMAGE_BITMAP "bncsql.png"
!define MUI_HEADERIMAGE_RIGHT

!insertmacro MUI_LANGUAGE "English"

Name "bncsql - $2"
OutFile "bncsql-$2-$3.exe"
InstallDir "\$PROGRAMFILES\\bncsql\\"

VIProductVersion                                         "$2.0"
VIAddVersionKey /LANG=\${LANG_ENGLISH} "ProductName"     "bncsql"
VIAddVersionKey /LANG=\${LANG_ENGLISH} "ProductVersion"  "$2"
VIAddVersionKey /LANG=\${LANG_ENGLISH} "Comments"        "blacknoise.at"
VIAddVersionKey /LANG=\${LANG_ENGLISH} "CompanyName"     "blacknoise.at"
VIAddVersionKey /LANG=\${LANG_ENGLISH} "LegalTrademarks" "bncsql Application of blacknoise.at"
VIAddVersionKey /LANG=\${LANG_ENGLISH} "LegalCopyright"  "blacknoise.at"
VIAddVersionKey /LANG=\${LANG_ENGLISH} "FileDescription" "bncsql Setup"
VIAddVersionKey /LANG=\${LANG_ENGLISH} "FileVersion"     "$2"

RequestExecutionLevel highest


#Function .onInit # Function that will be executed on installer's start up.
#  MessageBox MB_OK|MB_ICONINFORMATION "Hello world!" # Show a message that says "Hello world!".
#  Quit # Close the installer because this is a simple "Hello world!" installer.
#FunctionEnd
#Section # Useless section because this is a simple "Hello world!" installer.
#SectionEnd

#2do EstimatedSize
Section
    WriteRegStr   HKLM "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\bncsql" "DisplayName"     "bncsql"
    WriteRegStr   HKLM "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\bncsql" "DisplayVersion"  "$2"
    WriteRegStr   HKLM "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\bncsql" "Publisher"       "blacknoise.at"
    WriteRegStr   HKLM "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\bncsql" "URLInfoAbout"    "http://blacknoise.at/"
    WriteRegStr   HKLM "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\bncsql" "DisplayIcon"     "\$INSTDIR\\bncsql.ico"
    WriteRegDWORD HKLM "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\bncsql" "EstimatedSize"   0x00011811
    WriteRegStr   HKLM "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\bncsql" "UninstallString" "\$\\"\$INSTDIR\\uninstall.exe\$\\""

    SetOutPath \$INSTDIR
    WriteUninstaller "\$INSTDIR\\uninstall.exe"
    CreateDirectory  "\$SMPROGRAMS\\bncsql"
    CreateShortCut   "\$SMPROGRAMS\\bncsql\\bncsql.lnk" "\$INSTDIR\\bncsql.exe" "" "\$INSTDIR\\bncsql.ico" 0

$InFile

SectionEnd

Section "uninstall"

$UnDelete

    Delete "\$SMPROGRAMS\\bncsql\\bncsql.lnk"
    RmDir  "\$SMPROGRAMS\\bncsql"
    DeleteRegKey HKLM "Software\\Microsoft\\Windows\\CurrentVersion\\Uninstall\\bncsql"
    Delete "\$INSTDIR\\uninstall.exe"
    RmDir  "\$INSTDIR"
SectionEnd
EOF

    makensis bncsql.nsi || exit 1
#chmod 777  *.exe    || exit 2
    mkdir -p                         $4/
    install -pm 777 bncsql-$2-$3.exe $4/
    echo "Done...."
