#Copyright 2017-2018 blacknoise.at
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
import logging
from   kivy.app               import App
import sys
import time

import Version
from   bncSQLRSyncCrt         import *
from   bncSQLRSyncApp         import *
from   bncSQLLicense          import *
from   bncSQLInfo             import *
from   bncSQLProfile          import *
from   MainScreen             import *


class MainApp(App):
    sm = ScreenManager()
    scMainScreen = None

    def on_start(self):
	logging.info ( str ( self ) )
	from kivy.base import EventLoop
	EventLoop.window.bind(on_keyboard=self.hook_keyboard) #2do check @ reload, double bind ???

    def on_pause(self):
	logging.info ( str ( self ) )
	try:
	    self.root.current_screen.Pause ( self )
	except:
	    pass
	return True

    def on_resume(self):
	logging.info ( str ( self ) )
	try:
	    self.root.current_screen.Resume ( self )
	except:
	    pass

    def on_enter(self):
	logging.info ( str ( self ) )
	pass

    def hook_keyboard(self, window, key, *largs):
	#logging.info ( str ( self ) + " key=" + str ( key ) ) #bug4debug 2do sometimes no logging.info
	if key == 27: #Key - ESC
	    self.root.transition.direction = 'right'
	    #elf.root.current = self.root.screens[0].name
	    self.root.current = 'MainScreen'
	    return True
	if key == 286: #Key - F5
	    try:
		self.root.current_screen.Refresh ( self )
	    except:
		logging.error ( str ( self ) + " key=" + str ( key ) + " ! " + str ( self.root.current ) + ".Refresh ()" )
		pass
	    #Crash = Version.mainCrash #bug4debug
	    return True
	if key == 1073741942: #Android Menue
	    self.root.transition.direction = 'left'
	    self.root.current = 'bncSQLRSyncApp'
	    return True

    def open_settings(self, *largs): #Key - F1
	logging.info ( str ( self ) )
	self.root.transition.direction = 'left'
	self.root.current = 'bncSQLRSyncApp'

    def build ( self ):
	logging.info ( str ( self ) )
	self.title  = 'bncsql'
	self.icon   = 'icon.png'

	try:
	    self.Profile.DataBase.Clean ()
	except:
	    pass

	if self.scMainScreen:
	    self.sm.current = 'bncSQLRSyncApp'
	    self.sm.remove_widget ( self.scMainScreen )
	    del self.scMainScreen
	    if 'MainScreen' in sys.modules: del sys.modules["MainScreen"] #reload ( sys.modules["MainScreen"] )
	    from MainScreen import *
	    self.scMainScreen = MainScreen()
	    self.sm.add_widget ( self.scMainScreen )
	    self.sm.current = 'MainScreen'
	    return

	logging.info ( "self.sm=" + str ( self.sm ) )
	self.Profile     = bncSQLProfile()

	scbncSQLRSyncApp =      bncSQLRSyncApp() #Main Conf, Application
	self.sm.add_widget  ( scbncSQLRSyncApp )

	scbncSQLRSyncCrt =      bncSQLRSyncCrt() #Certificates
	self.sm.add_widget  ( scbncSQLRSyncCrt )

	scbncSQLLicense  =      bncSQLLicense()
	self.sm.add_widget  ( scbncSQLLicense )

	scbncSQLInfo     =      bncSQLInfo()
	self.sm.add_widget  ( scbncSQLInfo )

	self.sm.add_widget  ( self.Profile )

	self.scMainScreen     = MainScreen()
	logging.info ( "scMainScreen=" + str ( self.scMainScreen ) )
	self.sm.add_widget  ( self.scMainScreen )

	self.sm.current = 'MainScreen'
	#self.sm.current = 'bncSQLLicense'  #bug4debug
	#self.sm.current = 'bncSQLInfo'     #bug4debug
	#self.sm.current = 'bncSQLRSyncCrt' #bug4debug
	#self.sm.current = 'bncSQLRSyncApp' #bug4debug
	return self.sm
