#Copyright 2017-2018 blacknoise.at
#
#   Licensed under the Apache Info, Version 2.0 (the "Info");
#   you may not use this file except in compliance with the Info.
#   You may obtain a copy of the Info at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the Info is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the Info for the specific language governing permissions and
#   limitations under the Info.
#
#rom   kivy                   import kivy_home_dir
from   kivy.app               import App
from   kivy.uix.screenmanager import ScreenManager, Screen
from   kivy.uix.behaviors     import ButtonBehavior
from   kivy.uix.image         import Image
from   kivy.uix.gridlayout    import GridLayout
from   kivy.uix.textinput     import TextInput
from   kivy.uix.button        import Button
from   kivy.uix.popup         import Popup
from   kivy.lang              import Builder
from   kivy.uix.textinput     import TextInput
from   kivy.uix.checkbox      import CheckBox
from   kivy.metrics           import dp, sp
from   kivy.config            import Config
from   kivy.core.window       import Window

import re
import json
import logging

import os
import Version
from   bncSQLLib              import *
from   bncSQLTableKivy        import *


bncSQLInfo_kv = str ( '''
#:kivy 1.9.0
#:import hex kivy.utils.get_color_from_hex

<bncSQLInfo>:
    id: bncSQLInfo #outside = self
    name: 'bncSQLInfo'
    canvas.before:
        Color:
            rgb: hex('#FFFFFF')
        Rectangle:
            size: self.size
            pos:  self.pos

    BoxLayout:
        id: RootBox
        orientation: 'vertical'
        BoxLayout:
            size_hint: 1,None
            height: bncSQLInfo.Height
            pos_hint: {'top':1}
            ImageButton:
                source: 'go-previous-5.png'
                on_press: bncSQLInfo.GoBack ( self )
                allow_stretch: True
                keep_ratio:    True
                size_hint_y:   None
                size_hint_x:   None
                height:        self.parent.height * 1
                width:         self.height * self.image_ratio
            Label:
                text: 'Info'

        BoxLayout:
            id: TableInfo
            pos_hint: {'top':1}
''' )


class bncSQLInfo ( Screen ):
    #logging.debug ( "class bncSQLInfo" )

    def __init__(self, **kwargs):
	self.name   = 'bncSQLInfo'
	self.Height = 40 * Version.mainZoom
	self.tbInfo = bncSQLTableKivy();
	Builder.load_string (  bncSQLInfo_kv  )
	#uilder.load_file   ( 'bncSQLInfo.kv' )
	super(bncSQLInfo, self).__init__(**kwargs)
	logging.debug ( str ( self ) )
	SetBackground ( self, Version.mainBackground )

    def on_enter(self):
	logging.debug ( str ( self ) )
	self.Info ()

    def on_leave(self):
	logging.debug ( str ( self ) )
	self.ids.TableInfo.clear_widgets ()
	self.tbInfo.Close ()

    def GoBack(self, args):
	logging.debug ( str ( self ) + " args=" + str ( args ) )
	try:
	    self.parent.transition.direction = 'right'
	    self.parent.current = 'bncSQLRSyncApp'
	except:
	    logging.error ( str ( self ) )
	    pass

    def Info(self):
	KIVY_HOME = None
	try:
	    KIVY_HOME = os.environ['KIVY_HOME']
	except:
	    pass
	logging.debug ( str ( self ) )
	self.ids.TableInfo.clear_widgets ()
	self.tbInfo.Close ()
	self.tbInfo.HeaderShow   = 0
	self.tbInfo.Grid_Spacing = (0,0)
	self.tbInfo.Cols         = ['Key','Val']
	self.tbInfo.Rows         = [
	    [ 'PACKAGE_NAME'        , str ( Version.PACKAGE_NAME        ) ],
	    [ 'PACKAGE_VERSION'     , str ( Version.PACKAGE_VERSION     ) ],
	    [ 'PACKAGE_BUGREPORT'   , str ( Version.PACKAGE_BUGREPORT   ) ],
	    [ 'PACKAGE_URL'         , str ( Version.PACKAGE_URL         ) ],
	    [ 'PLATFORM'            , str ( Version.PLATFORM            ) ],
	    [ 'PREFIX'              , str ( Version.PREFIX              ) ],
	    [ 'BUILD_DATE_TIME'     , str ( Version.BUILD_DATE_TIME     ) ],
	    [ 'UNIX_SEC'            , str ( Version.UNIX_SEC            ) ],
	    [ 'TARGET'              , str ( Version.TARGET              ) ],
	    [ 'mainPwd'             , str ( Version.mainPwd             ) ],
	    [ 'mainPlatform'        , str ( Version.mainPlatform        ) ],
	    [ 'mainHome'            , str ( Version.mainHome            ) ],
	    [ 'mainLibPath'         , str ( Version.mainLibPath         ) ],
	    [ 'mainTemp'            , str ( Version.mainTemp            ) ],
	    [ 'mainApp'             , str ( Version.mainApp             ) ],
	    [ 'mainLogLevel'        , str ( Version.mainLogLevel        ) ],
	    [ 'mainLogStdio'        , str ( Version.mainLogStdio        ) ],
	    [ 'mainLogFile'         , str ( Version.mainLogFile         ) ],
	    [ 'mainLogSyslog'       , str ( Version.mainLogSyslog       ) ],
	    [ 'mainLogModul'        , str ( Version.mainLogModul        ) ],
	    [ 'mainLoad'            , str ( Version.mainLoad            ) ],
	    [ 'mainLoadAPI_Version' , str ( Version.mainLoadAPI_Version ) ],
	    [ 'mainLoadClientKey'   , str ( Version.mainLoadClientKey   ) ],
	    [ 'mainLoadMTime'       , str ( Version.mainLoadMTime       ) ],
	    [ 'mainLoadExpand'      , str ( Version.mainLoadExpand      ) ],
	    [ 'KIVY_HOME'           , str ( KIVY_HOME                   ) ],
	    [ 'mainBackground'      , str ( Version.mainBackground      ) ],
	    [ 'dp(1)'               , str ( dp(1)                       ) ],
	    [ 'Zoom'                , str ( Version.mainZoom            ) ],
	    [ 'ZoomPercent'         , str ( Config.get ( 'bncsql', 'ZoomPercent' ) ) ],
	    [ 'Window.width'        , str ( Window.width                ) ],
	    [ 'Window.height'       , str ( Window.height               ) ],
	]
	self.tbInfo.Draw ()
	logging.debug ( "tbInfo.Error=" + str ( self.tbInfo.Error ) + "=" )
	self.ids.TableInfo.add_widget ( self.tbInfo )
