#Copyright 2017-2018 blacknoise.at
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
from   kivy.app               import App
from   kivy.uix.gridlayout    import GridLayout
from   kivy.uix.boxlayout     import BoxLayout
from   kivy.uix.label         import Label
from   kivy.uix.button        import Button
from   kivy.uix.scrollview    import ScrollView
from   kivy.uix.popup         import Popup
from   kivy.uix.textinput     import TextInput
from   kivy.core.image        import Image
from   kivy.graphics          import Rectangle
from   kivy.lang              import Builder

import logging
import Version


def SetBackground (Widget, Background):
    #Widget.canvas.before.clear()
    #Widget.canvas.clear()
    if '' != Background:
	logging.info ( "Widget=" + str ( Widget ) + " Background=" + str ( Background ) )
	try:
	    imtexture = Image(Background).texture
	    with Widget.canvas.before:
		Rectangle(pos=(0, 0), size=(2200, 1300), texture=imtexture) #2do2 size from texture
	except:
	    pass


bncSQLPopup_kv = str ( '''
<PopupLabelBox>:
    id: PopupLabelBox
    orientation: "vertical"
    ScrollView:
        size_hint: 1,1
        Label:
            id: PopupText
            size_hint_y: None
            height: self.texture_size[1]
            text: 'abc'
            text_size: (self.width-20), None
            line_height: 1.5
            valign: "top"

    BoxLayout:
        id: PopupButtons
        size_hint: 1,None


<PopupInputBox>:
    id: PopupInputBox
    orientation: "vertical"
    ScrollView:
        size_hint: 1,1
        TextInput:
            id: PopupText

    BoxLayout:
        id: PopupButtons
        size_hint: 1,None


''' )


class PopupLabelBox (BoxLayout):
    def ButtonEvent(self, Button):
	try:    self.ButtonEventCB ( Button.Index )
	except: pass

class PopupInputBox (BoxLayout):
    def ButtonEvent(self, Button):
	try:    self.ButtonEventCB ( Button.Index )
	except: pass


class bncSQLPopup():
    EventIndex = None
    Text       = 'No Text'
    Title      = 'No Title'
    Buttons    = [ 'Yes', 'No' ]
    Layout     = 'Label'

    def __init__(self, **kwargs):
	Builder.load_string (  bncSQLPopup_kv  )
	#uilder.load_file   ( 'bncSQLPopup.kv' )
	#super(bncSQLPopup, self).__init__(**kwargs)
	#logging.info ( str ( self ) )

    def Draw(self):
	logging.info ( str ( self ) )
	self.Height = 40 * Version.mainZoom
	try:
	    self.popup = Version.popup
	except:
	    Version.popup = Popup ()
	    self.popup = Version.popup
	    self.popup.PopupLabelBox = PopupLabelBox ()
	    self.popup.PopupInputBox = PopupInputBox ()
	logging.info ( str ( self ) + " popup=" + str ( self.popup ) )
	if "TextInput" == self.Layout:
	    self.popup.content = self.popup.PopupInputBox
	else:
	    self.popup.content = self.popup.PopupLabelBox

	self.popup.dismiss()
	logging.info ( str ( self ) + " popup.content=" + str ( self.popup.content ) )
	self.popupBox = self.popup.content

	self.popupBox.ids.PopupButtons.clear_widgets()

    #Buttons
	for ButtonIndex in range ( len ( self.Buttons ) ):
	    #logging.info ( str ( self ) + " ButtonIndex=" + str ( ButtonIndex ) )
	    btn      = Button ()
	    btn.text = str ( self.Buttons[ButtonIndex] )
	    btn.Index= ButtonIndex
	    btn.bind(on_press=self.popupBox.ButtonEvent)
	    self.popupBox.ids.PopupButtons.add_widget (btn)

	self.popupBox.ButtonEventCB = self.Event
	self.popupBox.ids.PopupButtons.height = self.Height
	self.popupBox.ids.PopupText.text      = self.Text
	self.popup.title        = self.Title
	self.popup.size_hint    = None, None
	self.popup.pos_hint     = {'top': 1} #{'x': 0, 'y': .8}
	#elf.popup.pos_hint     = {'x': 10.0 / Window.width, 'y':99.0 / Window.height }
	self.popup.size         = 400, 400
	self.popup.x = 20
	#elf.popup.auto_dismiss =False #if on, catch keyboard
	#elf.popup.dismiss() 2do popup in popup
	self.popup.open()

    def Event(self, Index):
	self.popup.dismiss()
	logging.info ( str ( self ) + " Index=" + str ( Index ) )
	if "TextInput" == self.Layout:
	    self.Text = self.popupBox.ids.PopupText.text
	self.EventIndex = Index
	try:    self.EventCB ( self )
	except: pass


class AppMsg(App):
    Msg = 'Msg not found !'
    def build(self):
	logging.info ( str ( self ) )
	self.GridLayout = GridLayout ()
	PopupOK         = bncSQLPopup()
	PopupOK.Buttons = [ 'OK' ]
	PopupOK.Title   = "Error"
	PopupOK.Text    = self.Msg
	PopupOK.EventCB = self.AppMsgStop
	PopupOK.Draw()
	return self.GridLayout

    def on_stop(self):
	logging.info ( str ( self ) )

    def AppMsgStop(self, args):
	self.stop()
