#Copyright 2017-2018 blacknoise.at
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
from   kivy                   import kivy_home_dir
from   kivy.app               import App
from   kivy.uix.screenmanager import ScreenManager, Screen
from   kivy.lang              import Builder
from   kivy.uix.label         import Label
import logging
import os

import Version


bncSQLLicense_kv = str ( '''
#:kivy 1.9.0
#:import hex kivy.utils.get_color_from_hex

<bncSQLLicense>:
    id: bncSQLLicense #outside = self
    name: 'bncSQLLicense'

#Header
    BoxLayout:
        id: RootBox
        orientation: 'vertical'
        BoxLayout:
            size_hint: 1,None
            height: bncSQLLicense.Height
            pos_hint: {'top':1}
            canvas.before:
                Color:
                    rgb: hex('#000000')
                Rectangle:
                    size: self.size
                    pos:  self.pos
            ImageButton:
                source: 'go-previous-5.png'
                on_press: bncSQLLicense.GoBack ( self )
                allow_stretch: True
                keep_ratio:    True
                size_hint_y:   None
                size_hint_x:   None
                height:        self.parent.height * 1
                width:         self.height * self.image_ratio
            Label:
                text: 'License'

        BoxLayout:
            pos_hint: {'top':1}
            ScrollView:
                size_hint: 1,1
                pos_hint: {'top':1}
                id: LicenseScrollView
                canvas.before:
                    Color:
                        rgb: hex('#FFFFFF')
                    Rectangle:
                        size: self.size
                        pos:  self.pos
                do_scroll_x: True
                do_scroll_y: True
                Label:
                    id: LicenseLabel
                    text:      'License!!!'
                    size_hint_y: None
                    text_size: self.width, None
                    height: self.texture_size[1]
                    color:        hex('#000000')

''' )


class bncSQLLicense ( Screen ):
    #logging.info ( "class bncSQLLicense" )

    def __init__(self, **kwargs):
	self.name   = 'bncSQLLicense'
	self.Height = 40 * Version.mainZoom
	Builder.load_string (  bncSQLLicense_kv  )
	#uilder.load_file   ( 'bncSQLLicense.kv' )
	super(bncSQLLicense, self).__init__(**kwargs)
	logging.info ( str ( self ) )

    def on_enter(self):
	logging.info ( str ( self ) )
	self.License ()

    def on_leave(self):
	logging.info ( str ( self ) )

    def GoBack(self, args):
	logging.info ( str ( self ) + " args=" + str ( args ) )
	try:
	    self.parent.transition.direction = 'right'
	    self.parent.current = 'bncSQLRSyncApp'
	except:
	    logging.error ( str ( self ) )
	    pass

    def License(self):
	logging.debug ( str ( self ) )
	sLICENSE     = ""
	sNOTICE      = ""
	sLICENSE_EXT = ""
	licPath = Version.mainPwd
	if str ( Version.mainPlatform ) == 'linux':  licPath += "/.."
	if str ( Version.mainPlatform ) == 'macosx': licPath += "/.."
	if str ( Version.mainPlatform ) == 'win':    licPath += "/.."
	try:
	    #dirxList = str ( kivy_home_dir )                                                        #bug4debug
	    #logging.info ( "dirxList(" + dirxList + ")=" + str ( os.listdir ( dirxList ) ) + "=" )  #bug4debug
	    #kivy_home_dir_config = str ( kivy_home_dir ) + "/config.ini"                            #bug4debug
	    #logging.info ( str ( self ) + " kivy_home_dir_config=" + str ( kivy_home_dir_config ) ) #bug4debug
	    #with open ( kivy_home_dir_config ) as fLICENSE: sLICENSE = fLICENSE.read()              #bug4debug
	    with open ( os.path.join ( licPath, 'LICENSE' ) ) as fLICENSE: sLICENSE = fLICENSE.read()
	    fLICENSE.close ();
	except:
	    logging.error ( str ( self ) + " open ( 'LICENSE' )" )
	#except OSError, e:
	#    print e
	try:
	    with open ( os.path.join ( licPath, 'NOTICE' ) ) as fNOTICE: sNOTICE = fNOTICE.read()
	    fNOTICE.close ();
	except:
	    logging.error ( str ( self ) + " open ( 'NOTICE' )" )
	try:
	    with open ( os.path.join ( licPath, 'LICENSE.EXT' ) ) as fLICENSE_EXT: sLICENSE_EXT = fLICENSE_EXT.read()
	    fLICENSE_EXT.close ();
	except:
	    logging.error ( str ( self ) + " open ( 'LICENSE.EXT' )" )
	self.ids.LicenseLabel.text   = 'LICENSE\n' + str (sLICENSE) + str('\n\n\nNOTICE\n') + str (sNOTICE) + str('\n\n\nLICENSE EXTERNAL\n') + str (sLICENSE_EXT)
