#Copyright 2017-2018 blacknoise.at
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
from   kivy.app               import App
from   kivy.uix.screenmanager import ScreenManager, Screen
from   kivy.uix.behaviors     import ButtonBehavior
from   kivy.uix.image         import Image
from   kivy.uix.gridlayout    import GridLayout
from   kivy.uix.textinput     import TextInput
from   kivy.uix.button        import Button
from   kivy.uix.popup         import Popup
from   kivy.lang              import Builder
from   kivy.uix.textinput     import TextInput
from   kivy.uix.checkbox      import CheckBox
from   kivy.config            import Config
import re
import json
import logging

import Version
from   bncSQLLib              import *
from   bncSQLTableKivy        import *


bncSQLProfile_kv = str ( '''
#:kivy 1.9.0
#:import hex kivy.utils.get_color_from_hex

<bncSQLProfile>:
    id: bncSQLProfile
    name: 'bncSQLProfile'
    canvas.before:
        Color:
            rgb: hex('#FFFFFF')
        Rectangle:
            size: self.size
            pos:  self.pos

    BoxLayout:
        id: RootBox
        orientation: 'vertical'
        BoxLayout:
            size_hint: 1,None
            height: bncSQLProfile.Height
            pos_hint: {'top':1}
            ImageButton:
                source: 'go-previous-5.png'
                on_press: bncSQLProfile.GoBack ( self )
                allow_stretch: True
                keep_ratio:    True
                size_hint_y:   None
                size_hint_x:   None
                height:        self.parent.height * 1
                width:         self.height * self.image_ratio
            Label:
                text: 'Profile'

        BoxLayout:
            id: TableProfile
            pos_hint: {'top':.5}

        BoxLayout:
            id: TableQuery
            pos_hint: {'top':.5}

''' )


class bncSQLProfile ( Screen ):
    #logging.info ( "class bncSQLProfile" )

    def __init__(self, **kwargs):
	self.name            = 'bncSQLProfile'
	self.Height          = 40 * Version.mainZoom
	self.PACKAGE_VERSION = Version.PACKAGE_VERSION + "-" + Version.BUILD_DATE_TIME
	self.tbProfile       = bncSQLTableKivy();
	self.tbProfileDriver = bncSQLTable();
	self.tbQuerys         = bncSQLTableKivy();
	Builder.load_string (  bncSQLProfile_kv  )
	#uilder.load_file   ( 'bncSQLProfile.kv' )
	super(bncSQLProfile, self).__init__(**kwargs)
	#logging.info ( str ( self ) )
	SetBackground ( self, Version.mainBackground )
	self.DataBase = bncSQLDataBase ()
	self.Clean ()

    def Clean(self):
	self.Error    = ""
	self.DataBase.Clean ()
	self.Querys   = []
	self.Skin     = "default"
	self.Name     = None

    def  Show(self):
	logging.info ( str ( self ) )
	self.DataBase.Show ()
	logging.info ( str ( self ) + " Querys=" + str ( self.Querys ) )
	logging.info ( str ( self ) + " Skin  =" + str ( self.Skin   ) )

    def GetJson (self):
	logging.info ( str ( self ) )
	Profile = {
	    'DataBase'          : self.DataBase.GetJson (0),
	    'Querys'            : self.Querys              ,
	    'Skin'              : self.Skin                ,
	}
	return Profile

    def SetJson (self, sProfile):
	#logging.info ( str ( self ) + " sProfile=" + str ( sProfile ) + "=" )
	try:
	    jProfile = json.dumps ( sProfile )
	except:
	    pass
	try:
	    self.DataBase.SetJson ( json.dumps ( sProfile[ 'DataBase' ] ) )
	except:
	    pass
	try:
	    self.Querys = sProfile[ 'Querys' ] #1.0.1
	except:
	    pass
	try:
	    self.Querys = sProfile[ 'Query'  ] #1.0.0
	except:
	    pass
	try:
	    self.Skin   = sProfile[ 'Skin'   ]
	except:
	    pass
	#self.Show () #bug4debug

    def Write(self, Name):
	Profile = self.GetJson ()
	logging.info ( str ( self ) + " Profile=" + str ( Profile ) )
	try:
	    with open ( Name, 'w' ) as f: json.dump ( Profile, f )
	    f.close ();
	except:
	    pass #2do error

    def ReadNew(self, Name):
	logging.info ( str ( self ) + " Name=" + str ( Name ) )
	self.Clean ()
	self.Name = Name
	if not os.path.isfile ( Name ):
	    self.Write ( Name )
	self.Read ( Name )

    def Read(self, Name):
	logging.info ( str ( self ) + " Name=" + str ( Name ) )
	self.Clean ()
	self.Name = Name
	if not os.path.isfile ( Name ):
	    self.Error    = "File ~" + Name + "~ not found !"
	    return
	ProfileRX = {}
	try:
	    with open ( Name ) as f: ProfileRX = json.load ( f )
	    f.close ();
	except:
	    pass #2do error
	#logging.info ( str ( self ) + " ProfileRX=" + str ( ProfileRX ) )
	self.SetJson ( ProfileRX )

    def on_enter(self):
	logging.info ( str ( self ) + " Name=" + str ( self.Name ) )
	self.Profile ()
	self.QuerysShow ()

    def on_leave(self):
	logging.info ( str ( self ) )
	self.ids.TableProfile.clear_widgets ()
	self.ids.TableQuery.clear_widgets ()
	self.tbProfile.Close ()
	self.tbProfileDriver.Close ()
	self.tbQuerys.Close ()

    def GoBack(self, args):
	logging.info ( str ( self ) + " args=" + str ( args ) )
	try:
	    self.parent.transition.direction = 'right'
	    self.parent.current = 'bncSQLRSyncApp'
	except:
	    logging.error ( str ( self ) )
	    pass

#Profile
    def Profile(self):
	#logging.info ( str ( self ) )
	self.ids.TableProfile.clear_widgets ()
	self.DriverDropDowns = ['']
	self.tbProfileDriver.Close ()
	self.tbProfileDriver.Query = "bncsql driver show"
	self.tbProfileDriver.QueryRun()
	if self.tbProfileDriver.Error:
	    logging.info ( str ( self ) + " Error =" + str ( self.tbProfileDriver.Error ) )
	#logging.info ( str ( self ) + " Cols  =" + str ( self.tbProfileDriver.Cols  ) )
	#logging.info ( str ( self ) + " ColCnt=" + str ( self.tbProfileDriver.ColCnt) )
	#logging.info ( str ( self ) + " RowCnt=" + str ( self.tbProfileDriver.RowCnt) )
	for RowPos in range ( self.tbProfileDriver.RowCnt ):
	    Row = self.tbProfileDriver.Rows[RowPos]
	    #logging.info ( str ( self ) + " Row=" + str ( Row ) )
	    if "bncsql" == str ( Row[0] ): continue
	    self.DriverDropDowns += [ str ( Row[0] ) ]
	logging.info ( str ( self ) + " DriverDropDowns=" + str ( self.DriverDropDowns ) )

	self.tbProfile.Close ()
	self.tbProfile.Mirror          = 1
	self.tbProfile.HeaderShow      = 1
	self.tbProfile.Size_Hint_Min   = (40 * Version.mainZoom,40 * Version.mainZoom)
	self.tbProfile.Grid_Colorbg    = hex2color ( '#000000' )
	self.tbProfile.RowPre_CallBack = self.ProfileRowPre_CallBack
	self.tbProfile.RowPostCallBack = self.ProfileRowPostCallBack
	self.tbProfile.Cols = [
	    'Name'              ,
	    'Host'              ,
	    'Base'              ,
	    'User'              ,
	    'Pass'              ,
	    'Driver'            ,
	    'Port'              ,
	    'Options'           ,
	    'TLSCertificate'    ,
	    'TLSPrivateKey'     ,
	    'TLSPrivateKeyPass' ,
	    'TLSFingerprint00'  ,
	    'TLSFingerprint01'  ,
	    'TLSFingerprint02'  ,
	    'TLSFingerprint03'  ,
	    'TLSFingerprint04'  ,
	]
	self.tbProfile.Rows = [ [
	    self.Name                       ,
	    self.DataBase.Host              ,
	    self.DataBase.Base              ,
	    self.DataBase.User              ,
	    self.DataBase.Pass              ,
	    self.DataBase.Driver            ,
	    self.DataBase.Port              ,
	    self.DataBase.Options           ,
	    self.DataBase.TLSCertificate    ,
	    self.DataBase.TLSPrivateKey     ,
	    self.DataBase.TLSPrivateKeyPass ,
	    self.DataBase.TLSFingerprint00  ,
	    self.DataBase.TLSFingerprint01  ,
	    self.DataBase.TLSFingerprint02  ,
	    self.DataBase.TLSFingerprint03  ,
	    self.DataBase.TLSFingerprint04  ,
	], ]
	self.tbProfile.Draw ()
	self.ids.TableProfile.add_widget ( self.tbProfile )

    def ProfileUpdate(self, Key, Value):
	#logging.info ( str ( self ) + " Key=" + str ( Key ) + " Value=" + str ( Value ) )
	if   "Host"              == Key:    self.DataBase.Host              = str ( Value )
	elif "Base"              == Key:    self.DataBase.Base              = str ( Value )
	elif "Base"              == Key:    self.DataBase.User              = str ( Value )
	elif "Pass"              == Key:    self.DataBase.Pass              = str ( Value )
	elif "Driver"            == Key:    self.DataBase.Driver            = str ( Value )
	elif "Port"              == Key:
	    try:
		self.DataBase.Port = int ( Value )
	    except:
		pass
	elif "Options"           == Key:    self.DataBase.Options           = str ( Value )
	elif "TLSCertificate"    == Key:    self.DataBase.TLSCertificate    = str ( Value )
	elif "TLSPrivateKey"     == Key:    self.DataBase.TLSPrivateKey     = str ( Value )
	elif "TLSPrivateKeyPass" == Key:    self.DataBase.TLSPrivateKeyPass = str ( Value )
	elif "TLSFingerprint00"  == Key:    self.DataBase.TLSFingerprint00  = str ( Value )
	elif "TLSFingerprint01"  == Key:    self.DataBase.TLSFingerprint01  = str ( Value )
	elif "TLSFingerprint02"  == Key:    self.DataBase.TLSFingerprint02  = str ( Value )
	elif "TLSFingerprint03"  == Key:    self.DataBase.TLSFingerprint03  = str ( Value )
	elif "TLSFingerprint04"  == Key:    self.DataBase.TLSFingerprint04  = str ( Value )
	#self.DataBase.Show ()
	self.Write ( self.Name )

    def ProfileTextSyntax(self, Widget, Value ):
	#logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + " Value =" + str ( Value  ) )
	pass

    def ProfileDropDown(self, Widget, Value):
	#logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + " Value =" + str ( Value  ) )
	self.ProfileUpdate ( Widget.ColName, Value )

    def ProfileTextValidate(self, Widget):
	#logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	self.ProfileUpdate ( Widget.ColName, Widget.text )

    def ProfileRowPre_CallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if   0 == tb.Data_Row and "Name"   == str ( tb.ColName ):
	    pass
	elif 0 == tb.Data_Row and "Driver" == str ( tb.ColName ):
	    tb.Layout    = "DropDown"
	    tb.DropDowns = self.DriverDropDowns
	elif 0 == tb.Data_Row:
	    tb.Layout = "TextInput"

    def ProfileRowPostCallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
    #Header
	if -1 == tb.Data_Row:
	    Widget.halign = 'right'
    #Data
	elif 0 == tb.Data_Row and "Driver" == str ( tb.ColName ):
	    Widget.disabled = False
	    Widget.bind ( text             = self.ProfileDropDown     )
	elif 0 == tb.Data_Row:
	    Widget.disabled = False
	    Widget.bind ( text             = self.ProfileTextSyntax   )
	    Widget.bind ( on_text_validate = self.ProfileTextValidate )
	    if   "Pass"           == str ( tb.ColName ): Widget.password = True
	    #elif "TLSCertificate" == str ( tb.ColName ): Widget.multiline = True 2do bind
	    #elif "TLSPrivateKey"  == str ( tb.ColName ): Widget.multiline = True 2do bind
#Profile

#list Querys
    def QuerysDelete(self, Widget):
	#logging.info ( str ( self ) + " Widget           =" + str ( Widget            ) )
	if 0 != Widget.EventIndex: return
	#logging.info ( str ( self ) + " Widget.EventIndex=" + str ( Widget.EventIndex ) )
	#logging.info ( str ( self ) + " Widget.EventArg  =" + str ( Widget.EventArg   ) )
	#logging.info ( str ( self ) + " Widget.Text      =" + str ( Widget.Text       ) )
	QueryPos = Widget.EventArg
	logging.info ( str ( self ) + " QueryPos=" + str ( QueryPos ) + " Querys=" + str ( self.Querys ) )
	try:
	    del self.Querys[ int ( QueryPos ) ]
	    self.Write ( self.Name )
	except:
	    pass
	self.QuerysShow ()

    def QuerysDeleteYesNo(self, Widget):
	#logging.info ( str ( self ) + " Widget.Data_Row=" + str ( Widget.Data_Row ) )
	try:
	    YesNo          = bncSQLPopup()
	    YesNo.Title    = "Msg"
	    YesNo.Text     = "Delete query at pos (" + str ( Widget.Data_Row ) + ") ?"
	    YesNo.EventCB  = self.QuerysDelete
	    YesNo.EventArg = str ( Widget.Data_Row )
	    YesNo.Draw()
	except:
	    pass

    def QuerysInsert(self, Widget):
	logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	try:
	    Query = [
		str ( self.QuerysInsertQuery.text       ),
		int ( self.QuerysInsertAutoStart.active ),
		int ( self.QuerysInsertHeader.active    ),
		int ( self.QuerysInsertRefresh.text     ),
	    ]
	    logging.info ( str ( self ) + " Query=" + str ( Query ) )
	    self.Querys += [ Query ]
	    self.Write ( self.Name )
	except:
	    pass
	self.QuerysShow ()

    def QuerysEdit(self, Widget, Value):
	#logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + " Widget.ColName=" + str ( Widget.ColName ) + " Value=" + str ( Value ) )
	Write = 0
	if "Query" == str ( Widget.ColName ) and False == Value: #lost focus
	    #logging.info ( str ( self ) + " Widget.Data_Row=" + str ( Widget.Data_Row ) + " Widget.text=" + str ( Widget.text ) )
	    try:
		TextOld = self.Querys[ Widget.Data_Row ][0]
		#logging.info ( str ( self ) + " TextOld=" + str ( TextOld ) )
		if TextOld != Widget.text:
		    self.Querys[ Widget.Data_Row ][0] = Widget.text
		    Write = 1
	    except:
		pass
	elif "AutoStart" == str ( Widget.ColName ):
	    self.Querys[ Widget.Data_Row ][1] = int ( Value )
	    Write = 1
	elif "Header" == str ( Widget.ColName ):
	    self.Querys[ Widget.Data_Row ][2] = int ( Value )
	    Write = 1

	#logging.info ( str ( self ) + " Write=" + str ( Write ) )
	if Write:
	    self.Write ( self.Name )

    def QuerysRowPre_CallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if    0 <= tb.Data_Row:
	#Edit
	    if   "Query"     == str ( tb.ColName ): tb.Layout = "TextInput"
	    elif "AutoStart" == str ( tb.ColName ): tb.Layout = "CheckBox"
	    elif "Header"    == str ( tb.ColName ): tb.Layout = "CheckBox"
    #Insert
	elif -2 == tb.Data_Row:
	    if -1 == tb.Data_Col: pass
	    if   "Query"     == str ( tb.ColName ): tb.Layout = "TextInput"
	    elif "AutoStart" == str ( tb.ColName ): tb.Layout = "CheckBox"
	    elif "Header"    == str ( tb.ColName ): tb.Layout = "CheckBox"

    def QuerysRowPostCallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if    0 <= tb.Data_Row:
	#Delete
	    if -1 == tb.Data_Col:
		Widget.bind ( on_release=self.QuerysDeleteYesNo )
		Widget.disabled = False
	#Edit
	    elif "Query" == str ( tb.ColName ):
		Widget.bind ( focus=self.QuerysEdit )
		Widget.disabled  = False
		Widget.multiline = True
	    elif "AutoStart" == str ( tb.ColName ):
		Widget.bind ( active=self.QuerysEdit )
		Widget.disabled  = False
	    elif "Header"    == str ( tb.ColName ):
		Widget.bind ( active=self.QuerysEdit )
		Widget.disabled  = False
	    elif "Refresh"    == str ( tb.ColName ):
		Widget.valign    = "middle"
    #Insert
	elif -2 == tb.Data_Row:
	    if -1 == tb.Data_Col:
		Widget.bind ( on_release=self.QuerysInsert )
		self.QuerysInsertButton = Widget
		self.QuerysInsertButton.disabled = False
		self.QuerysInsertButton.source = 'edit-add.png'
	    elif "Query" == str ( tb.ColName ):
		Widget.disabled  = False
		Widget.multiline = True
		self.QuerysInsertQuery = Widget
	    elif "AutoStart" == str ( tb.ColName ):
		Widget.disabled  = False
		self.QuerysInsertAutoStart = Widget
	    elif "Header"    == str ( tb.ColName ):
		Widget.disabled  = False
		Widget.active    = 1
		self.QuerysInsertHeader  = Widget
	    elif "Refresh"    == str ( tb.ColName ):
		Widget.disabled  = True
		Widget.text      = "0"
		Widget.valign    = "middle"
		self.QuerysInsertRefresh = Widget

    def QuerysShow(self):
	logging.info ( str ( self ) )
	self.ids.TableQuery.clear_widgets ()
	self.tbQuerys.Close ()
	self.tbQuerys.Size_Hint_Min   = (40 * Version.mainZoom,40 * Version.mainZoom)
	self.tbQuerys.Grid_Colorbg    = hex2color ( '#000000' )
	self.tbQuerys.RowPre_CallBack = self.QuerysRowPre_CallBack
	self.tbQuerys.RowPostCallBack = self.QuerysRowPostCallBack
	self.tbQuerys.DeletePos       = 0
	self.tbQuerys.Insert          = 1
	logging.info ( str ( self ) + " Querys=" + str ( self.Querys ) )
	self.tbQuerys.Cols   = [ #2do via class Query...
	    'Query'    ,
	    'AutoStart',
	    'Header'   ,
	    'Refresh'  ,
	]
	for QueryPos in range ( len ( self.Querys ) ):
	    Query = self.Querys[ QueryPos ]
	    logging.info ( str ( self ) + " Query=" + str ( Query ) )
	    self.tbQuerys.Rows   += [ Query ]
	self.tbQuerys.Draw ()
	self.ids.TableQuery.add_widget ( self.tbQuerys )
#list Querys done
