#Copyright 2017-2018 blacknoise.at
#
#   You may use this file WITHOUT CHANGES according to Apache License, Version 2.0.
#   Modifications of this file is NOT allowed without prior written permission.
#   For written permission, please contact us via http://www.blacknoise.at/?Contact
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
from   kivy.app               import App
from   kivy.uix.screenmanager import ScreenManager, Screen
from   kivy.uix.behaviors     import ButtonBehavior
from   kivy.uix.image         import Image
from   kivy.uix.gridlayout    import GridLayout
from   kivy.uix.textinput     import TextInput
from   kivy.uix.button        import Button
from   kivy.uix.popup         import Popup
from   kivy.lang              import Builder
from   kivy.uix.textinput     import TextInput
from   kivy.uix.checkbox      import CheckBox
from   kivy.config            import Config

import time
import re
import json
import logging
import webbrowser

import Version
from   bncSQLLib              import *
from   bncSQLTableKivy        import *


#logging.debug ( "import" )


bncSQLRSyncApp_kv = str ( '''
#:kivy 1.9.0
#:import hex kivy.utils.get_color_from_hex

<bncSQLRSyncApp>:
    id: bncSQLRSyncApp #outside = self
    name: 'bncSQLRSyncApp'

#Header
    BoxLayout:
        id: RootBox
        orientation: 'vertical'
        BoxLayout:
            size_hint: 1,None
            height: bncSQLRSyncApp.Height
            pos_hint: {'top':1}
#bgimg            canvas.before:
#bgimg                Color:
#bgimg                    rgb: hex('#000000')
#bgimg                Rectangle:
#bgimg                    size: self.size
#bgimg                    pos:  self.pos
            ImageButton:
                source: 'go-previous-5.png'
                on_press: bncSQLRSyncApp.GoBack ( self )
                allow_stretch: True
                keep_ratio:    True
                size_hint_y:   None
                size_hint_x:   None
                height:        self.parent.height * 1
                width:         self.height * self.image_ratio
            Label:
                text: 'Application ' + bncSQLRSyncApp.PACKAGE_VERSION
            ImageButton:
                source: 'system-shutdown-6.png'
                on_press: bncSQLRSyncApp.Exit ( self )
                allow_stretch: True
                keep_ratio:    True
                size_hint_y:   None
                size_hint_x:   None
                height:        self.parent.height * 1
                width:         self.height * self.image_ratio

        BoxLayout:
            id: TableConf
            pos_hint: {'top':.5}

        BoxLayout:
            id: TableApp
            pos_hint: {'top':.5}

''' )


class bncSQLRSyncApp ( Screen ):
    #logging.info ( "class bncSQLRSyncApp" )

    def __init__(self, **kwargs):
	self.name      = 'bncSQLRSyncApp'
	self.Height    = 40 * Version.mainZoom
	self.PACKAGE_VERSION = Version.PACKAGE_VERSION #rc-mode + "-" + Version.BUILD_DATE_TIME
	self.tbConf    = bncSQLTableKivy ()
	self.tbConfApp = bncSQLTable ()
	self.tbApp     = bncSQLTableKivy ()
	Builder.load_string (  bncSQLRSyncApp_kv  )
	#uilder.load_file   ( 'bncSQLRSyncApp.kv' )
	super(bncSQLRSyncApp, self).__init__(**kwargs)
	logging.info ( str ( self ) )
	SetBackground ( self, Version.mainBackground )

    def on_enter(self):
	logging.info ( str ( self ) )
	self.Conf ()
	self.Apps ()

    def on_leave(self):
	logging.info ( str ( self ) )
	self.ids.TableApp.clear_widgets ()
	self.tbConf.Close ()
	self.tbConfApp.Close ()
	self.tbApp.Close ()

    def GoBack(self, args):
	logging.info ( str ( self ) + " args=" + str ( args ) )
	try:
	    self.parent.transition.direction = 'right'
	    #elf.parent.current = self.parent.screens[0].name
	    self.parent.current = 'MainScreen'
	except:
	    logging.error ( str ( self ) )
	    pass

    def Exit(self, args):
	logging.info ( str ( self ) + " args=" + str ( args ) )
	Version.mainApp.stop ()

#Config
    def Conf(self):
	#logging.info ( str ( self ) )
	self.LoadDropDowns = ['']
	self.tbConfApp.Close ()
	self.tbConfApp.Query    = "bncsql application show '" + str ( Version.mainHome ) + "',0"
	self.tbConfApp.QueryRun()
	if self.tbConfApp.Error:
	    logging.error ( str ( self ) + " tbConfApp.Error =" + str ( self.tbConfApp.Error ) )
	#logging.info ( str ( self ) + " tbConfApp.Cols  =" + str ( self.tbConfApp.Cols  ) )
	#logging.info ( str ( self ) + " tbConfApp.ColCnt=" + str ( self.tbConfApp.ColCnt) )
	#logging.info ( str ( self ) + " tbConfApp.RowCnt=" + str ( self.tbConfApp.RowCnt) )
	for RowPos in range ( self.tbConfApp.RowCnt ):
	    Row = self.tbConfApp.Rows[RowPos]
	    #logging.info ( str ( self ) + " Row=" + str ( Row ) )
	    self.LoadDropDowns += [ str ( Row[0] ) + "." + str ( Row[3] ) ]
	#logging.info ( str ( self ) + " LoadDropDowns=" + str ( self.LoadDropDowns ) )

	self.ids.TableConf.clear_widgets ()
	self.tbConf.Close ()
	#cbHeader.cb.disabled = True #2do PC = F1, Android = Menue, iOS=???
	self.HeaderHint = 'Header press F1'
	if 'android' == Version.mainPlatform:
	    self.HeaderHint = 'Header press Menu'
	self.tbConf.Mirror = 1
	self.tbConf.Cols   = [
	    'Load'         ,
	    'ZoomPercent'  ,
	    'Download'     ,
	    self.HeaderHint,
	    'QueryPrompt'  ,
	    'Tables'       ,
	    'Certificates' ,
	    'Donate'       ,
	    'License'      ,
	    'Info'         ,
	    'LogLevel'     ,
	    'Background'   ,
	]
	self.tbConf.Rows   = [ [
	    Config.get ( 'bncsql', 'Load'        ),
	    Config.get ( 'bncsql', 'ZoomPercent' ),
	    Config.get ( 'bncsql', 'Download'    ),
	    Config.get ( 'bncsql', 'Header'      ),
	    Config.get ( 'bncsql', 'QueryPrompt' ),
	    Config.get ( 'bncsql', 'Tables'      ),
	    'Certificates'                        ,
	    'Donate'                              ,
	    'License'                             ,
	    'Info'                                ,
	    Config.get ( 'bncsql', 'LogLevel'    ),
	    Config.get ( 'bncsql', 'Background'  ),
	], ]
	self.tbConf.Updates = [
	    '1',
	    '1',
	    '1',
	    '1',
	    '1',
	    '1',
	    '1',
	    '1',
	    '1',
	    '1',
	    '1',
	    '1',
	]
	self.tbConf.Size_Hint_Min = (40 * Version.mainZoom,40 * Version.mainZoom)
	self.tbConf.RowPre_CallBack = self.ConfRowPre_CallBack
	self.tbConf.RowPostCallBack = self.ConfRowPostCallBack
	self.tbConf.Grid_Colorbg    = hex2color ( '#000000' )
	self.tbConf.Draw ()
	#logging.info ( "tbConf.Error=" + str ( self.tbConf.Error ) + "=" )
	self.ids.TableConf.add_widget ( self.tbConf )

    def ConfRowPre_CallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	if 0 != tb.Data_Row: return
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if   "Load"          == tb.ColName:
	    tb.Layout    = "DropDown"
	    tb.DropDowns = self.LoadDropDowns
	elif "Download"      == tb.ColName: tb.Layout = "CheckBox"
	elif self.HeaderHint == tb.ColName:
	    tb.Layout    = "CheckBox"
	elif "Profiles"      == tb.ColName: tb.Layout = "CheckBox"
	elif "QueryPrompt"   == tb.ColName: tb.Layout = "CheckBox"
	elif "Tables"        == tb.ColName:
	    tb.Layout    = "DropDown"
	    tb.DropDowns = ['1','2','4']
	elif "Certificates"  == tb.ColName: tb.Layout = "Button"
	elif "Donate"        == tb.ColName: tb.Layout = "Button"
	elif "License"       == tb.ColName: tb.Layout = "Button"
	elif "Info"          == tb.ColName: tb.Layout = "Button"
	elif "LogLevel"      == tb.ColName:
	    tb.Layout    = "DropDown"
	    tb.DropDowns = ['0','1','2','3','4','5','6','7','8','9']
	elif "Background"    == tb.ColName:
	    tb.Layout    = "DropDown"
	    tb.DropDowns = ['','background-pexels-photo-459301.png','background-pexels-photo-207130.png', 'background-pexels-photo-241544.png'] #2do list...
	elif "ZoomPercent"   == tb.ColName:
	    tb.Layout    = "TextInput"

    def ConfRowPostCallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	Widget.halign    = 'right'
	Widget.valign    = 'middle'
	if not tb.Update: return
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if   "CheckBox"  == tb.Layout: Widget.bind ( active   = self.ConfUpdateCheck )
	elif "DropDown"  == tb.Layout: Widget.bind ( text     = self.ConfUpdateCheck )
	elif "Button"    == tb.Layout: Widget.bind ( on_press = self.ConfButtonCheck )
	elif "TextInput" == tb.Layout: Widget.bind ( focus    = self.ConfUpdateCheck )

    def ConfButtonCheck(self, Widget):
	#logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + " Widget.ColName=" + str ( Widget.ColName ) )
	if "Certificates" == Widget.ColName:
	    try:
		self.parent.transition.direction = 'left'
		self.parent.current = 'bncSQLRSyncCrt'
	    except:
		logging.error ( str ( self ) )
		pass
	elif "Donate" == Widget.ColName:
	    webbrowser.open("http://www.blacknoise.at/?bncsql&donate")
	elif "License" == Widget.ColName:
	    try:
		self.parent.transition.direction = 'left'
		self.parent.current = 'bncSQLLicense'
	    except:
		logging.error ( str ( self ) )
		pass
	elif "Info" == Widget.ColName:
	    try:
		self.parent.transition.direction = 'left'
		self.parent.current = 'bncSQLInfo'
	    except:
		logging.error ( str ( self ) )
		pass

    def QuerysDeleteX(self, Widget):
	#logging.info ( str ( self ) + " Widget           =" + str ( Widget            ) )
	logging.info ( str ( self ) + " Widget.EventIndex=" + str ( Widget.EventIndex ) )
	if 1 == Widget.EventIndex: Version.mainReload = 1
	Version.mainApp.stop ()

    def ConfUpdateCheck(self, Widget, Value):
	#logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	logging.info ( str ( self ) + " Widget.ColName=" + str ( Widget.ColName ) + " Value=" + str ( Value ) )
	if "Load" == Widget.ColName:
	    ValueOld = Config.get ( 'bncsql', 'Load' )
	    if "" == ValueOld: ValueOld = "dummy.bncsql"
	    Config.set   ( 'bncsql', 'Load'       , str ( Value ) )
	    Config.write ()
	    if "" == Value: Value = "empty.bncsql"
	    Version.mainLoad = Config.get ( 'bncsql', 'Load' )
	    if Value.endswith ( '.bncsql' ) and ValueOld.endswith ( '.bncsql' ):
		try:
		    self.parent.transition.direction = 'right'
		    self.parent.current = 'MainScreen'
		except:
		    pass
	    else:
	    #just reload @ change from to bncsql/bncbin
		YesNo         = bncSQLPopup()
		YesNo.Title   = "Restart App"
		YesNo.Text    = "Exit your app and start it new !\nIf you continue the display may be incorrect."
		YesNo.Buttons = [ 'EXIT APP', "Continue" ]
		YesNo.EventCB = self.QuerysDeleteX
		YesNo.Draw()

	elif "Download" == Widget.ColName:
	    Config.set   ( 'bncsql', 'Download'   , int ( Value ) )
	    Config.write ()
	    self.Apps     ()
	elif self.HeaderHint == Widget.ColName:
	    if "ios-arm64" == Version.PLATFORM: Value = 1
	    if "ios-armv7" == Version.PLATFORM: Value = 1
	    Config.set   ( 'bncsql', 'Header'     , int ( Value ) )
	    Config.write ()
	elif "Profiles" == Widget.ColName:
	    Config.set   ( 'bncsql', 'Profiles'   , int ( Value ) )
	    Config.write ()
	elif "QueryPrompt" == Widget.ColName:
	    Config.set   ( 'bncsql', 'QueryPrompt', int ( Value ) )
	    Config.write ()
	elif "Tables" == Widget.ColName:
	    Config.set   ( 'bncsql', 'Tables'     , int ( Value ) )
	    Config.write ()
	elif "LogLevel" == Widget.ColName:
	    Config.set   ( 'bncsql', 'LogLevel'   , int ( Value ) )
	    Config.write ()
	    Version.mainLogLevel = Config.get ( 'bncsql', 'LogLevel' )
	elif "Background" == Widget.ColName:
	    Config.set   ( 'bncsql', 'Background' , str ( Value ) )
	    Config.write ()
	    Version.mainBackground = Config.get ( 'bncsql', 'Background' )
	    Version.mainReload = 1
	    Version.mainApp.stop ()
	elif "ZoomPercent" == Widget.ColName:
	    if True == Value: return #check only @ focus lost
	    ZoomPercent = 0
	    try:
		ZoomPercent = int ( Widget.text )
	    except:
		pass
	    if  49 >= ZoomPercent: ZoomPercent = 0 #min
	    if 301 <= ZoomPercent: ZoomPercent = 0 #max
	    if 0 == ZoomPercent:
		Widget.text = Config.get ( 'bncsql', 'ZoomPercent' )
		return #invald
	    if ZoomPercent == Config.get ( 'bncsql', 'ZoomPercent' ): return # no change
	    logging.info ( str ( self ) + "ZoomPercent=" + str ( ZoomPercent ) )
	    Config.set   ( 'bncsql', 'ZoomPercent' , str ( ZoomPercent ) )
	    Config.write ()
	    Version.mainReload = 1
	    Version.mainApp.stop ()
#Config done


#list all Apps on client
    def AppDownload(self, arg):
	#logging.info ( str ( self ) + " arg=" + str ( arg ) )
	try:
	    Download = arg.Download
	    #logging.info ( str ( self ) + " Download=" + str ( Download ) )
	    TriggerFile = os.path.join ( Version.mainTemp, str ( Download[0] ) + "." + str ( Download[3] ), "app.info" )
	    logging.info ( str ( self ) + " TriggerFile=" + str ( TriggerFile ) )
	    try:    os.remove ( TriggerFile )
	    except: pass
	    tbDownload          = bncSQLTable    ()
	    tbDownload.Query = "bncsql application download '" + str ( Version.mainHome ) + "'" + ",'" + str ( Download[0] ) + "'" + ",'" + str ( Download[3] ) + "'" + ",'" + str ( Download[4] ) + "'"
	    logging.info ( str ( self ) + " tbDownload.Query=" + str ( tbDownload.Query ) )
	    tbDownload.QueryRun ()
	    if tbDownload.Error:
		logging.info ( "tbDownload.Error=" + str ( tbDownload.Error ) + "=" )
		PopupOK         = bncSQLPopup()
		PopupOK.Buttons = [ 'OK' ]
		PopupOK.Title   = "Error"
		PopupOK.Text    = str ( tbDownload.Error )
		PopupOK.Draw()
	    tbDownload.Close ()
	except:
	    pass
	if ( str ( Download[0] ) + "." + str ( Download[3] ) ) == str ( Config.get ( 'bncsql', 'load' ) ):
	    Version.mainReload = 1
	    Version.mainApp.stop ()
	else:
	    self.Conf ()
	    self.Apps ()

    def AppDelete(self, Widget):
	logging.info ( str ( self ) + " Widget =" + str ( Widget  ) )
	if 0 != Widget.EventIndex: return
	AppName = Widget.EventArg
	logging.info ( str ( self ) + " AppName=" + str ( AppName ) )
	TriggerFile = os.path.join ( Version.mainTemp, AppName, "app.info" )
	logging.info ( str ( self ) + " TriggerFile=" + str ( TriggerFile ) )
	try:    os.remove ( TriggerFile ) #2do2 rm -rvf
	except: pass
	tbDelete       = bncSQLTable();
	tbDelete.Query = "bncsql application delete '" + os.path.join ( Version.mainHome, AppName ) + "'"
	tbDelete.QueryRun ()
	if tbDelete.Error:
	    logging.error ( "tbDelete.Error=" + str ( tbDelete.Error ) + "=" )
	    PopupOK         = bncSQLPopup() #bug2 Popup in Popup from AppDeleteYesNo
	    PopupOK.Buttons = [ 'OK' ]
	    PopupOK.Title   = "Error"
	    PopupOK.Text    = str ( tbDelete.Error )
	    PopupOK.Draw()
	tbDelete.Close ()
	if str ( AppName ) == str ( Config.get ( 'bncsql', 'load' ) ):
	    Config.set ( 'bncsql', 'Load', '' )
	    Config.write()
	    Version.mainReload = 1
	    Version.mainApp.stop ()
	else:
	    self.Conf ()
	    self.Apps ()

    def AppDeleteYesNo(self, args):
	#logging.info ( str ( self ) + " args=" + str ( args ) )
	try:
	    AppName = args.Delete
	    #logging.info ( str ( self ) + " AppName=" + str ( AppName ) )
	    YesNo          = bncSQLPopup()
	    YesNo.Title    = "Msg"
	    YesNo.Text     = 'Delete application ' + str ( AppName ) + ' ?'
	    YesNo.EventCB  = self.AppDelete
	    YesNo.EventArg = AppName
	    YesNo.Draw()
	except:
	    pass

    def AppInsert(self, args):
	#logging.info ( str ( self ) + " args=" + str ( args ) )
	try:
	    AppName = self.AppInsertName.text + ".bncsql"
	    logging.info ( str ( self ) + " AppName=" + str ( AppName ) )
	    Version.mainApp.Profile.ReadNew ( os.path.join ( Version.mainHome, AppName ) )
	    self.parent.transition.direction = 'left'
	    self.parent.current = 'bncSQLProfile'
	except:
	    pass

    def AppUpdateCheck(self, Widget, Value ):
	#logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + " Value =" + str ( Value  ) )
	if "Name" == Widget.ColName:
	    if re.compile ( r'^[@a-zA-Z0-9._-]+$' ).match ( Value ):
		self.InsertButton.disabled = False
		self.InsertButton.source = 'edit-add.png'
	    else:
		self.InsertButton.disabled = True
		self.InsertButton.source = 'edit-add-bw.png'

    def AppEdit(self, args):
	#logging.info ( str ( self ) + " args=" + str ( args ) )
	try:
	    AppName = args.Edit
	    logging.info ( str ( self ) + " AppName=" + str ( AppName ) )
	    Version.mainApp.Profile.Read ( os.path.join ( Version.mainHome, AppName ) )
	    self.parent.transition.direction = 'left'
	    self.parent.current = 'bncSQLProfile'
	except:
	    pass

    def AppRowPre_CallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if    0 <= tb.Data_Row and "USec" == str ( tb.ColName ):
	    tb.Layout = "Button"
	elif -2 == tb.Data_Row and "USec" == str ( tb.ColName ):
	    tb.Layout = "Label"
	    tb.Data   = ""
	elif -2 == tb.Data_Row and "Name" == str ( tb.ColName ):
	    tb.Layout = "TextInput"
	    tb.Data   = ""

    def AppRowPostCallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if 0 <= tb.Data_Row and "USec" == str ( tb.ColName ):
	    if "0" <> str ( tb.Row[tb.Data_Col] ):
		Widget.bind ( on_release=self.AppDownload )
		Widget.disabled = False
		Widget.text     = "Download" #2do image
		Widget.Download = tb.Row
	    else:
		Widget.text = "" #2do image
		Widget.disabled = True
    #Delete
	elif 0 <= tb.Data_Row and -1 == tb.Data_Col:
	    Widget.bind ( on_release=self.AppDeleteYesNo )
	    Widget.disabled = False
	    Widget.Delete = str ( tb.ColumnGet ( "Name" ) ) + "." + str ( tb.ColumnGet ( "Type" ) )
    #Edit
	elif 0 <= tb.Data_Row and -2 == tb.Data_Col:
	    if "bncsql" == str ( tb.ColumnGet ( "Type" ) ):
		Widget.bind ( on_release=self.AppEdit )
		Widget.disabled = False
		Widget.Edit = str ( tb.ColumnGet ( "Name" ) ) + "." + str ( tb.ColumnGet ( "Type" ) )
	    else:
		Widget.source = 'edit-4-bw.png'
		Widget.disabled = True
    #Insert
	elif -2 == tb.Data_Row and "Name" == str ( tb.ColName ):
	    Widget.disabled = False
	    Widget.bind ( text=self.AppUpdateCheck )
	    self.AppInsertName = Widget
	elif -2 == tb.Data_Row and -1 == tb.Data_Col:
	    Widget.bind ( on_release=self.AppInsert )
	    self.InsertButton = Widget
	    self.InsertButton.disabled = True
	    self.InsertButton.source = 'edit-add-bw.png'

    def Apps(self):
	logging.info ( str ( self ) )
	self.ids.TableApp.clear_widgets ()
	self.tbApp.Close ()
	self.tbApp.Query           = "bncsql application show " + str ( Version.mainHome ) + "," + Config.get ( 'bncsql', 'Download' ) +"'"
	self.tbApp.Size_Hint_Min   = (40 * Version.mainZoom,40 * Version.mainZoom)
	self.tbApp.Grid_Colorbg    = hex2color ( '#000000' )
	self.tbApp.RowPre_CallBack = self.AppRowPre_CallBack
	self.tbApp.RowPostCallBack = self.AppRowPostCallBack
	self.tbApp.DeletePos       = 0
	self.tbApp.Insert          = 1
	self.tbApp.EditPos         = 2
	self.tbApp.Draw ()
	#logging.info ( "tbApp.Error=" + str ( self.tbApp.Error ) + "=" )
	self.ids.TableApp.add_widget ( self.tbApp )
#list all Apps on client done
