#Copyright 2017-2018 blacknoise.at
#
#   You may use this file WITHOUT CHANGES according to Apache License, Version 2.0.
#   Modifications of this file is NOT allowed without prior written permission.
#   For written permission, please contact us via http://www.blacknoise.at/?Contact
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
from kivy.app               import App
from kivy.uix.screenmanager import ScreenManager, Screen
from kivy.uix.behaviors     import ButtonBehavior
from kivy.uix.image         import Image
from kivy.uix.gridlayout    import GridLayout
from kivy.uix.textinput     import TextInput
from kivy.uix.button        import Button
from kivy.uix.popup         import Popup
from kivy.lang              import Builder
from kivy.uix.textinput     import TextInput
from kivy.uix.checkbox      import CheckBox
import re
import json
import logging

import Version
from   bncSQLLib            import *
from   bncSQLTableKivy      import *


#logging.debug ( "import" )

class ImageButton(ButtonBehavior, Image): pass


bncSQLRSyncCrt_kv = str ( '''
#:kivy 1.9.0
#:import hex kivy.utils.get_color_from_hex

<bncSQLRSyncCrt>:
    id: bncSQLRSyncCrt
    name: 'bncSQLRSyncCrt'
    canvas.before:
        Color:
            rgb: hex('#FFFFFF')
        Rectangle:
            size: self.size
            pos:  self.pos

    BoxLayout:
        id: RootBox
        orientation: 'vertical'
        BoxLayout:
            size_hint: 1,None
            height: bncSQLRSyncCrt.Height
            pos_hint: {'top':1}
            ImageButton:
                source: 'go-previous-5.png'
                on_press: bncSQLRSyncCrt.GoBack ( self )
                allow_stretch: True
                keep_ratio:    True
                size_hint_y:   None
                size_hint_x:   None
                height:        self.parent.height * 1
                width:         self.height * self.image_ratio
            Label:
                text: 'Certificate'

        BoxLayout:
            id: TableData
            pos_hint: {'top':1}
''' )


class bncSQLRSyncCrt ( Screen ):
    #logging.info ( "class bncSQLRSyncCrt" )
    tbCrt = bncSQLTableKivy();

    def __init__(self, **kwargs):
	self.name   = 'bncSQLRSyncCrt'
	self.Height = 40 * Version.mainZoom
	Builder.load_string (  bncSQLRSyncCrt_kv  )
	#uilder.load_file   ( 'bncSQLRSyncCrt.kv' )
	super(bncSQLRSyncCrt, self).__init__(**kwargs)
	logging.info ( str ( self ) )
	SetBackground ( self, Version.mainBackground )

    def on_enter(self):
	logging.info ( str ( self ) )
	self.Crts ()

    def on_leave(self):
	logging.info ( str ( self ) )
	self.ids.TableData.clear_widgets ()
	self.tbCrt.Close ()

    def GoBack(self, args):
	logging.info ( str ( self ) + " args=" + str ( args ) )
	try:
	    self.parent.transition.direction = 'right'
	    self.parent.current = 'bncSQLRSyncApp'
	except:
	    logging.error ( str ( self ) )
	    pass

#list all certs on client
    def CrtInsert(self, arg):
	#logging.info ( str ( self ) + " arg=" + str ( arg ) )
	try:
	    if "" == self.CrtInsertName: return
	    #logging.info ( str ( self ) + " CrtInsertName=" + str ( self.CrtInsertName ) + " CrtInsertUpload=" + str ( self.CrtInsertUpload ) )
	    InsTB       = bncSQLTable();
	    InsTB.Query = "bncsql certificate create '" + os.path.join ( str ( Version.mainHome ), str ( self.CrtInsertName ) ) + ".crt',''," + str ( self.CrtInsertUpload )
	    logging.info ( str ( self ) + " InsTB.Query=" + str ( InsTB.Query ) )
	    InsTB.QueryRun ()
	    if InsTB.Error:
		logging.error ( "InsTB.Error=" + str ( InsTB.Error ) + "=" )
		PopupOK         = bncSQLPopup()
		PopupOK.Buttons = [ 'OK' ]
		PopupOK.Title   = "Error: "
		PopupOK.Text    = str ( InsTB.Error )
		PopupOK.Draw()
	    InsTB.Close ()
	    self.Crts()
	except:
	    pass

    def CrtUpdateCheck(self, Widget, Value ):
	#logging.info ( str ( self ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + " Value =" + str ( Value  ) )
	if 'Name' == Widget.ColName:
	    if re.compile ( r'^[@a-zA-Z0-9._-]+$' ).match ( Value ):
		self.CrtInsertButton.disabled = False
		self.CrtInsertButton.source   = 'edit-add.png'
		self.CrtInsertName = Value
	    else:
		self.CrtInsertButton.disabled = True
		self.CrtInsertButton.source   = 'edit-add-bw.png'
		self.CrtInsertName = ""
	elif 'Upload' == Widget.ColName:
	    self.CrtInsertUpload = int ( Value )

    def CrtDelete(self, arg):
	#logging.info ( str ( self ) + " arg=" + str ( arg ) )
	try:
	    Delete = arg.Delete
	    #logging.info ( str ( self ) + " Delete=" + str ( Delete ) )
	    YesNo          = bncSQLPopup()
	    YesNo.Title    = "Msg"
	    YesNo.Text     = "Delete certificate " + str ( Delete ) + " ?"
	    YesNo.EventCB    = self.CrtDeleteAction
	    YesNo.EventArg = Delete
	    YesNo.Draw()
	except:
	    pass

    def CrtDeleteAction(self, Widget):
	logging.info ( str ( self ) + " Widget =" + str ( Widget  ) )
	if 0 != Widget.EventIndex: return
	CrtName = Widget.EventArg
	logging.info ( str ( self ) + " CrtName=" + str ( CrtName ) )
	DelTB       = bncSQLTable();
	DelTB.Query = "bncsql certificate delete '" + os.path.join ( str ( Version.mainHome ), str ( CrtName ) ) + "'"
	DelTB.QueryRun ()
	if DelTB.Error:
	    logging.error ( "DelTB.Error=" + str ( DelTB.Error ) + "=" )
	    PopupOK        = bncSQLPopup()  #bug2 Popup in Popup from AppDeleteYesNo
	    PopupOK.Buttons = [ 'OK' ]
	    PopupOK.Title   = "Error"
	    PopupOK.Text    = str ( DelTB.Error )
	    PopupOK.Draw()
	DelTB.Close ()
	self.Crts()

    def CrtUpload(self, arg):
	#logging.info ( str ( self ) + " arg=" + str ( arg ) )
	try:
	    Upload = arg.Upload
	    logging.info ( str ( self ) + " Upload=" + str ( Upload ) )
	    tbUpload          = bncSQLTable ()
	    tbUpload.Query = "bncsql certificate upload '" + os.path.join ( str ( Version.mainHome ), str ( Upload ) ) + "'"
	    logging.info ( str ( self ) + " tbUpload.Query=" + str ( tbUpload.Query ) )
	    tbUpload.QueryRun ()
	    if tbUpload.Error:
		logging.info ( "tbUpload.Error=" + str ( tbUpload.Error ) + "=" )
		PopupOK         = bncSQLPopup()
		PopupOK.Buttons = [ 'OK' ]
		PopupOK.Title   = "Error"
		PopupOK.Text    = str ( tbUpload.Error )
		PopupOK.Draw()
	    tbUpload.Close ()
	except:
	    pass

    def CrtRowPre_CallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if    0 <= tb.Data_Row and "Upload" == str ( tb.ColName ):
	    tb.Layout = "Button" #2do image
    #Insert
	elif -2 == tb.Data_Row and "Upload" == str ( tb.ColName ):
	    tb.Layout = "CheckBox"
	elif -2 == tb.Data_Row and "Name"   == str ( tb.ColName ):
	    tb.Layout = "TextInput"

    def CrtRowPostCallBack(self, tb, Widget):
	#logging.info ( str ( self ) + " tb=" + str ( tb ) + " Widget=" + str ( Widget ) )
	#logging.info ( str ( self ) + "Data=(" + str ( tb.Data_Col ) + "," + str ( tb.Data_Row ) + ")" + " tb.ColName=" + str ( tb.ColName ) )
	if    0 <= tb.Data_Row and "Upload" == str ( tb.ColName ):
	    Widget.bind ( on_release=self.CrtUpload )
	    Widget.disabled = False
	    Widget.text     = "Upload"
	    Widget.Upload   = str ( tb.ColumnGet ( "Name" ) )
	    if "testbncsql.blacknoise.at.crt" == Widget.Upload:
		Widget.Upload   = ""
		Widget.disabled = True #2do disable.png
    #Insert
	elif -2 == tb.Data_Row and "Upload" == str ( tb.ColName ):
	    Widget.bind ( active=self.CrtUpdateCheck )
	    Widget.disabled      = False
	    Widget.active        = True
	    self.CrtInsertUpload = int ( Widget.active )
	elif -2 == tb.Data_Row and "Name"   == str ( tb.ColName ):
	    Widget.bind ( text=self.CrtUpdateCheck )
	    Widget.disabled    = False
	    self.CrtInsertName = ""
	elif -2 == tb.Data_Row and -1 == tb.Data_Col:
	    Widget.bind ( on_release=self.CrtInsert )
	    self.CrtInsertButton = Widget
	    self.CrtInsertButton.disabled = True
	    self.CrtInsertButton.source = 'edit-add-bw.png'
    #Delete
	elif 0 <= tb.Data_Row and -1 == tb.Data_Col:
	    Widget.bind ( on_release=self.CrtDelete )
	    Widget.disabled = False
	    Widget.Delete = str ( tb.ColumnGet ( "Name" ) )
	    if "testbncsql.blacknoise.at.crt" == Widget.Delete:
		Widget.Delete = ""
		Widget.disabled = True

    def Crts(self):
	logging.info ( str ( self ) )
	self.ids.TableData.clear_widgets ()
	self.tbCrt.Close ()
	self.tbCrt.Query           = "bncsql certificate show '" + str ( Version.mainHome ) + "'"
	self.tbCrt.Size_Hint_Min   = (40 * Version.mainZoom,40 * Version.mainZoom)
	self.tbCrt.Grid_Colorbg    = hex2color ( '#000000' )
	self.tbCrt.RowPre_CallBack = self.CrtRowPre_CallBack
	self.tbCrt.RowPostCallBack = self.CrtRowPostCallBack
	self.tbCrt.DeletePos       = 0
	self.tbCrt.Insert          = 1
	self.tbCrt.Draw ()
	if self.tbCrt.Error:
	    logging.error ( "tbCrt.Error=" + str ( self.tbCrt.Error ) + "=" )
	self.ids.TableData.add_widget ( self.tbCrt )
