#Copyright 2017-2018 blacknoise.at
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
import os
import json
import logging

import Version
from   libbncsql_py import *


class bncSQLDataBase ():

    def __init__(self, **kwargs):
	logging.debug ( str ( self ) )
	self.Clean ()

    def Clean(self):
	self.Error             = ''
	self.Host              = ''
	self.Base              = ''
	self.User              = ''
	self.Pass              = ''
	self.Driver            = ''
	self.Port              =  0
	self.Options           = ''
	self.TLSCertificate    = ''
	self.TLSPrivateKey     = ''
	self.TLSPrivateKeyPass = ''
	self.TLSFingerprint00  = ''
	self.TLSFingerprint01  = ''
	self.TLSFingerprint02  = ''
	self.TLSFingerprint03  = ''
	self.TLSFingerprint04  = ''
	self.LogLevel          =  0
	self.LogStdio          = ''
	self.LogFile           = ''
	self.LogSyslog         =  0
	self.LogModul          = ''

    def Show (self):
	#ogging.info ( str ( self ) + " Error             =" + str ( self.Error             ) + "=" )
	logging.info ( str ( self ) + " Host              =" + str ( self.Host              ) + "=" )
	logging.info ( str ( self ) + " Base              =" + str ( self.Base              ) + "=" )
	logging.info ( str ( self ) + " User              =" + str ( self.User              ) + "=" )
	logging.info ( str ( self ) + " Pass              =" + str ( self.Pass              ) + "=" )
	logging.info ( str ( self ) + " Driver            =" + str ( self.Driver            ) + "=" )
	logging.info ( str ( self ) + " Port              =" + str ( self.Port              ) + "=" )
	logging.info ( str ( self ) + " Options           =" + str ( self.Options           ) + "=" )
	logging.info ( str ( self ) + " TLSCertificate    =" + str ( self.TLSCertificate    ) + "=" )
	logging.info ( str ( self ) + " TLSPrivateKey     =" + str ( self.TLSPrivateKey     ) + "=" )
	logging.info ( str ( self ) + " TLSPrivateKeyPass =" + str ( self.TLSPrivateKeyPass ) + "=" )
	logging.info ( str ( self ) + " TLSFingerprint00  =" + str ( self.TLSFingerprint00  ) + "=" )
	logging.info ( str ( self ) + " TLSFingerprint01  =" + str ( self.TLSFingerprint01  ) + "=" )
	logging.info ( str ( self ) + " TLSFingerprint02  =" + str ( self.TLSFingerprint02  ) + "=" )
	logging.info ( str ( self ) + " TLSFingerprint03  =" + str ( self.TLSFingerprint03  ) + "=" )
	logging.info ( str ( self ) + " TLSFingerprint04  =" + str ( self.TLSFingerprint04  ) + "=" )
	logging.info ( str ( self ) + " LogLevel          =" + str ( self.LogLevel          ) + "=" )
	logging.info ( str ( self ) + " LogStdio          =" + str ( self.LogStdio          ) + "=" )
	logging.info ( str ( self ) + " LogFile           =" + str ( self.LogFile           ) + "=" )
	logging.info ( str ( self ) + " LogSyslog         =" + str ( self.LogSyslog         ) + "=" )
	logging.info ( str ( self ) + " LogModul          =" + str ( self.LogModul          ) + "=" )

    def SetJson (self, sDataBase):
	logging.debug ( str ( self ) + " sDataBase=" + str ( sDataBase ) + "=" )
	try:
	    jDataBase = json.loads ( sDataBase )
	except:
	    pass
	try:
	    self.Host              = jDataBase[ 'dbHost'              ]
	except:
	    pass
	try:
	    self.Base              = jDataBase[ 'dbBase'              ]
	except:
	    pass
	try:
	    self.User              = jDataBase[ 'dbUser'              ]
	except:
	    pass
	try:
	    self.Pass              = jDataBase[ 'dbPass'              ]
	except:
	    pass
	try:
	    self.Driver            = jDataBase[ 'dbDriver'            ]
	except:
	    pass
	try:
	    self.Port              = jDataBase[ 'dbPort'              ]
	except:
	    pass
	try:
	    self.Options           = jDataBase[ 'dbOptions'           ]
	except:
	    pass
	try:
	    self.TLSCertificate    = jDataBase[ 'dbTLSCertificate'    ]
	except:
	    pass
	try:
	    self.TLSPrivateKey     = jDataBase[ 'dbTLSPrivateKey'     ]
	except:
	    pass
	try:
	    self.TLSPrivateKeyPass = jDataBase[ 'dbTLSPrivateKeyPass' ]
	except:
	    pass
	try:
	    self.TLSFingerprint00  = jDataBase[ 'dbTLSFingerprint00'  ]
	except:
	    pass
	try:
	    self.TLSFingerprint01  = jDataBase[ 'dbTLSFingerprint01'  ]
	except:
	    pass
	try:
	    self.TLSFingerprint02  = jDataBase[ 'dbTLSFingerprint02'  ]
	except:
	    pass
	try:
	    self.TLSFingerprint03  = jDataBase[ 'dbTLSFingerprint03'  ]
	except:
	    pass
	try:
	    self.TLSFingerprint04  = jDataBase[ 'dbTLSFingerprint04'  ]
	except:
	    pass
	try:
	    self.LogLevel          = jDataBase[ 'dbLogLevel'          ]
	except:
	    pass
	try:
	    self.LogStdio          = jDataBase[ 'dbLogStdio'          ]
	except:
	    pass
	try:
	    self.LogFile           = jDataBase[ 'dbLogFile'           ]
	except:
	    pass
	try:
	    self.LogSyslog         = jDataBase[ 'dbLogSyslog'         ]
	except:
	    pass
	try:
	    self.LogModul          = jDataBase[ 'dbLogModul'          ]
	except:
	    pass

    def GetJson (self, WithPath):
	logging.debug ( str ( self ) )
	DataBase = {
	    'dbHost'              : self.Host              ,
	    'dbBase'              : self.Base              ,
	    'dbUser'              : self.User              ,
	    'dbPass'              : self.Pass              ,
	    'dbDriver'            : self.Driver            ,
	    'dbPort'              : self.Port              ,
	    'dbOptions'           : self.Options           ,
	    'dbTLSCertificate'    : self.TLSCertificate    ,
	    'dbTLSPrivateKey'     : self.TLSPrivateKey     ,
	    'dbTLSPrivateKeyPass' : self.TLSPrivateKeyPass ,
	    'dbTLSFingerprint00'  : self.TLSFingerprint00  ,
	    'dbTLSFingerprint01'  : self.TLSFingerprint01  ,
	    'dbTLSFingerprint02'  : self.TLSFingerprint02  ,
	    'dbTLSFingerprint03'  : self.TLSFingerprint03  ,
	    'dbTLSFingerprint04'  : self.TLSFingerprint04  ,
	}
	if WithPath:
	    DataBase['dbHome'     ] = Version.mainHome
	    DataBase['dbLibPath'  ] = Version.mainLibPath
	    DataBase['dbLogLevel' ] = Version.mainLogLevel
	    DataBase['dbLogStdio' ] = Version.mainLogStdio
	    DataBase['dbLogFile'  ] = os.path.join ( Version.mainHome, Version.mainLogFile )
	    DataBase['dbLogSyslog'] = Version.mainLogSyslog
	    DataBase['dbLogModul' ] = Version.mainLogModul
	return DataBase


class bncSQLTable():
    Handle       = None
    DataBaseSelf = bncSQLDataBase ()

    def __init__(self):
	logging.debug ( str ( self ) + " bncSQLTable" )
	self.Close ()

    def __del__(self):
	logging.debug ( str ( self ) + " bncSQLTable" )
	self.Close ()

    def Close(self):
	logging.debug ( str ( self ) + " bncSQLTable" )
	#self.DataBaseSelf.Close () 2do @ bncSQLDataBase
	self.DataBase = None
	self.Error    = ''
	self.Cols     = []
	self.ColCnt   = 0
	self.Rows     = []
	self.RowCnt   = 0
	self.Query    = ''
	self.Types    = []
	if self.Handle:
	    logging.debug ( str ( self ) + " bncsqlDelete Handle=" + str ( self.Handle ) )
	    bncsqlDelete ( self.Handle )
	self.Handle = None

    def QueryRun(self):
	logging.debug ( str ( self ) )
	if self.Error: return
	if self.Cols and not self.ColCnt:
	    self.ColCnt = len ( self.Cols )
	    self.RowCnt = len ( self.Rows )
	    if not self.ColCnt: self.Error = 'No ColCnt'
	if self.Error: return
	if self.ColCnt: return #Query already done
	if not self.Query: self.Error = 'No Query'
	if self.Error: return
	#logging.debug ( str ( self ) + " self.Query=" + str ( self.Query ) ) #bug4debug
	if not self.DataBase: self.DataBase = self.DataBaseSelf
	if self.Error: return
	#self.DataBase.Show () #bug4debug
	jDataBase = self.DataBase.GetJson (1)
	jNew         = json.loads ( bncsqlNew ( json.dumps ( jDataBase ) ) )
	logging.debug ( str ( self ) + " jNew=" + str ( jNew ) )
	self.Error   = jNew[ 'Error'  ]
	self.Handle  = jNew[ 'Handle' ]
	if self.Error: return
	jRoot = json.loads ( bncsqlQuery ( self.Handle, self.Query ) )
	#logging.debug ( "jRoot=" + str ( jRoot ) ) #bug4debug
	self.Error  = jRoot[ 'Error'  ]
	if self.Error: return
	self.Cols   = jRoot[ 'Cols'   ]
	self.ColCnt = jRoot[ 'ColCnt' ]
	self.Types  = jRoot[ 'Types'  ]
	if 0 < self.ColCnt:
	    RowPos = 0
	    while 1:
		self.jRecord = json.loads ( bncsqlRecord ( self.Handle, str ( RowPos ) ) )
		RowPos += 1
		#logging.debug ( str ( self ) + " jRecord=" + str ( self.jRecord ) ) #bug4debug
		self.Error = self.jRecord[ 'Error'  ]
		if self.Error: return
		Fokus = self.jRecord[ 'Fokus'  ]
		if -1 == Fokus: break
		self.Rows   += [ self.jRecord[ 'Record' ] ]
		self.RowCnt += 1

	logging.debug ( str ( self ) + " bncsqlDelete Handle=" + str ( self.Handle ) )
	bncsqlDelete ( self.Handle )
	self.Handle = None
