#Copyright 2017-2018 blacknoise.at
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
from   kivy.app               import App
from   kivy.uix.screenmanager import ScreenManager, Screen
from   kivy.uix.gridlayout    import GridLayout
from   kivy.uix.button        import Button
from   kivy.uix.label         import Label
from   kivy.lang              import Builder
from   kivy.properties        import NumericProperty
from   kivy.uix.textinput     import TextInput
from   kivy.uix.behaviors     import ButtonBehavior
from   kivy.uix.image         import Image
from   kivy.uix.scrollview    import ScrollView
from   kivy.lang              import Builder
from   kivy.utils             import platform
from   kivy.uix.image         import Image
from   kivy.uix.checkbox      import CheckBox
from   kivy.uix.dropdown      import DropDown
from   kivy.metrics           import dp, sp

from   kivy.graphics          import *
from   kivy.properties        import ListProperty
from   kivy.utils             import get_color_from_hex

import os
import logging
import json
import base64
from   tempfile import mkstemp

from   bncSQLTable            import *
import Version


def hex2color(color):
    return get_color_from_hex (color)


bncSQLTableKivy_kv = str ( '''
#:kivy 1.9.0
#:import hex kivy.utils.get_color_from_hex

<bncSQLTableKivy>:
    #self.size_hint          = (1,1)
    #self.pos_hint           = {'top':1}
    #self.do_scroll_x        = True
    #self.do_scroll_y        = True
#bgimg    colorbg:      (0,0,0,1)
#bgimg    canvas.before:
#bgimg        Color:
#bgimg            rgb: self.colorbg
#bgimg        Rectangle:
#bgimg            size: self.size
#bgimg            pos:  self.pos

<bncSQLTableKivyGrid>:
#bgimg    colorbg:      (0,0,0,1)
#bgimg    canvas.before:
#bgimg        Color:
#bgimg            rgb: self.colorbg
#bgimg        Rectangle:
#bgimg            size: self.size
#bgimg            pos:  self.pos

<bncSQLLabel>:
    size_hint:     (None, None)
    size_hint_max: (800 , None) #! ok here, else evSize
    #ize_hint_min: (250 , 250 ) #! ok here, else evSize
    texture_size:  self.size
    halign:        'right' # | 'left'
    valign:        'top'   # | 'bottom'
    shorten:       False
    shorten_from:  'right'
    color:        (0,0,0,1)
    colorbg:      (1,1,1,1)
    canvas.before:
        Color:
            rgb: self.colorbg
        Rectangle:
            size: self.size
            pos:  self.pos

<bncSQLTextInput>:
    size_hint:     None, None
    size_hint_min: 100,33
    multiline:     False

<bncSQLCheckBox>:
    size_hint:     None, None
    size:          50,50
    colorbg:      (0,0,0,1)
    color:        (1,1,1,1)
    canvas.before:
        Color:
            rgb: self.colorbg
        Rectangle:
            size: self.size
            pos:  self.pos

<bncSQLImageButton>
    size_hint:     None, None
    size:          50,50

<bncSQLImageButton2do>:
    color:        (0,1,0,1)
    canvas.before:
        Color:
            rgb: (1,0,0,1)
        Rectangle:
            texture: self.texture
            size: self.size
            pos:  self.pos


<bncSQLImageFull>:
    canvas:
        Color:
            rgb: (1, 1, 1)
        Rectangle:
            texture: self.texture
            size: self.size
            pos:  self.pos

''' )


class bncSQLTableKivyGrid(GridLayout): pass


class bncSQLLabel(Label): #h,valign ok !!!!!

    def __init__(self, **kwargs):
	super(bncSQLLabel, self).__init__( **kwargs)
	self.bind ( texture_size=self.Resize )

    def Resize(self, Self, Size):
	#logging.debug ( str ( self ) + " Size=" + str ( Size ) )
	#logging.debug ( str ( self ) + " Size=" + str ( Size ) + " _label=" + str ( self._label.content_size ) )
	if self.size_hint_max[0] <= Size[0]: #2do via size_hint_max_x
	    self.width     = Size[0] / 2
	    self.height    = Size[1] * 3 #char width != height, 1 spare line
	    self.text_size = self.size
	else:
	    self.size      = Size
	    self.text_size = Size
	self._label.refresh ()


class bncSQLTextInput(TextInput): #OK 004

    def __init__(self, **kwargs):
	super(bncSQLTextInput, self).__init__( **kwargs)
	if str ( Version.mainPlatform ) != 'android': #2do android @ long text, iteration clock warning, maybe @ small sceens
	    self.bind ( text=self.Retext )

    def Retext(self, Self, Text):
	#logging.debug ( str ( self ) )
	#logging.debug ( str ( self ) + " Text=" + str ( Text ) + " _lines_labels=" + str ( self._lines_labels ) )
	SetWidth  = 0
	SetHeight = 0
	for Line in range ( len ( self._lines_labels ) ):
	    #logging.debug ( str ( self ) + " Line=" + str ( Line ) )
	    Texture       = self._lines_labels[Line]
	    TextureWidth  = Texture.size[0]
	    SetHeight    += Texture.size[1]
	    if TextureWidth > SetWidth: SetWidth = TextureWidth
	SetWidth  += 15
	SetHeight += 15
	if self.size_hint_min[0] > SetWidth:  SetWidth  = self.size_hint_min[0]
	if self.size_hint_min[1] > SetHeight: SetHeight = self.size_hint_min[1]
	#logging.debug ( str ( self ) + " SetWidth=" + str ( SetWidth ) + " SetHeight=" + str ( SetHeight ) )
	self.width  = SetWidth
	self.height = SetHeight


class bncSQLButton(Button):
    pass
    #size_hint = (None,None) #!!! important, else height and width has no effect, crash @ android


class bncSQLCheckBox(CheckBox):
    pass


class bncSQLImageFull(ButtonBehavior,Image): #OK 001
    def __init__(self, **kwargs):
	super(bncSQLImageFull, self).__init__( **kwargs)

    def on_size(self, widget, size):
	#logging.debug ( str ( self ) + "self.size        =" + str(self.size        ) ) #self.size same as size
	#logging.debug ( str ( self ) + "self.texture_size=" + str(self.texture_size) )
	#logging.debug ( str ( self ) + "self.size_hint   =" + str(self.size_hint   ) )
	#logging.debug ( str ( self ) + "self.width       =" + str(self.width       ) )
	#logging.debug ( str ( self ) + "self.height      =" + str(self.height      ) )
	if 0 == self.texture_size[0]: return
	self.parent.height = self.texture_size[1] * self.parent.width/self.texture_size[0]


class bncSQLDropDown(Button):
    pass


class bncSQLImageButton(ButtonBehavior, Image):
    pass


class bncSQLColumn (): #V 1.5
    RowPre_CallBack = None
    RowPostCallBack = None
    DeleteIsSet     = 0
    EditIsSet       = 0
    Layouts         = []
    Updates         = []
    DropDowns       = []

    def SetColumn(self, Index):
	#logging.debug ( str ( self ) + " Index =" + str ( Index       ) )
	Grid_Row      = -1
	Grid_Col      = -1
	self.Data_Row = -9
	self.Data_Col = -9
	self.Layout   = None
	self.Update   = None
	self.Data     = None
	Widget        = None
	self.Colorbg  = None
	self.ColName  = ""

	if not self.Mirror:
	    Grid_Col = int ( Index % self.Grid.cols )
	    Grid_Row = int ( Index / self.Grid.cols )
	else:
	    Grid_Col = int ( Index / self.Grid.cols )
	    Grid_Row = int ( Index % self.Grid.cols )
	#logging.debug ( str ( self ) + " Index =" + str ( Index ) + " mod= " + str ( Grid_Row ) + " " + str ( Grid_Col ) )

	if 0 == Grid_Row and self.HeaderShow:
	    self.Data_Col = Grid_Col
	    self.Data_Row = -1 #Header
	elif self.HeaderShow:
	    self.Data_Col = Grid_Col
	    self.Data_Row = Grid_Row - 1
	else:
	    self.Data_Col = Grid_Col
	    self.Data_Row = Grid_Row
	
	if self.Data_Row >= self.RowCnt: self.Data_Row = -2 #Insert

    #colunm update/edit
	if not Grid_Col:
	    self.DeleteIsSet = 0
	    self.EditIsSet   = 0
	if self.DeletePos == Grid_Col:
	    self.Data_Col    = -1 #Delete
	    self.DeleteIsSet = 1
	elif self.EditPos == Grid_Col:
	    self.Data_Col    = -2 #Edit
	    self.EditIsSet   = 1
	else:
	    self.Data_Col    = Grid_Col
	if 0 <= self.Data_Col:
	    self.Data_Col -= self.DeleteIsSet
	    self.Data_Col -= self.EditIsSet

	if self.Data_Col >= self.ColCnt: self.Data_Col = -8 #Error Col out of index

	if 0 <= self.Data_Col and 0 <= self.Data_Row:
	#real Data
	    self.ColName = str ( self.Cols[self.Data_Col] )
	    self.Row     = self.Rows[ self.Data_Row ]
	    self.Data    = str ( self.Row[self.Data_Col] )
	#self.Layout via self.Layouts[]
	    try:
		self.Layout = self.Layouts[self.Data_Col]
		if '' == self.Layout: self.Layout = None
	    except:
		self.Layout = None
	#Update via Updates[]
	    try:
		self.Update      = self.Updates[self.Data_Col]
		if '' == self.Update: self.Update = None
	    except:
		self.Update      = None
	elif -1 == self.Data_Row:
	#Header
	    if 0 <= self.Data_Col:
		self.ColName = str ( self.Cols[self.Data_Col] )
		self.Data    = self.ColName
	    else:
		self.ColName = ""
		self.Data    = " " #space, else col.width = 0
	elif -2 == self.Data_Row:
	#Insert
	    if 0 <= self.Data_Col:
		self.ColName = str ( self.Cols[self.Data_Col] )
		self.Data    = "" #bug2 read from defaults
		#2do self.Layout  = "TextInput" --> if Update
	    elif -1 == self.Data_Col:
		self.Data    = "edit-add.png"
		self.Layout  = "ImageButton"
	    else:
		self.Data    = " "
	elif -1 == self.Data_Col:
	#Delete
	    self.Data    = "user-trash-2.png"
	    self.Layout  = "ImageButton"
	elif -2 == self.Data_Col:
	#Edit
	    self.Data    = "edit-4.png"
	    self.Layout  = "ImageButton"

    #Type via Types[]
	try:
	    self.Type      = self.Types[self.Data_Col]
	    if '' == self.Type: self.Type = None
	except:
	    self.Type      = None

	#self.Data = "Grid=(" + str ( Grid_Col ) + "," + str ( Grid_Row ) + ")" + "Data=(" + str ( self.Data_Col ) + "," + str ( self.Data_Row ) + ")" #bug4debug
	#logging.debug ( str ( self ) + " ColName=" + str ( self.ColName ) + " Layout=" + str ( self.Layout ) + " Update=" + str ( self.Update ) + " Type=" + str ( self.Type ) )
	if self.RowPre_CallBack: self.RowPre_CallBack ( self, Widget )

    #Draw
	if     "bn_blob"   == self.Type and 0 <= self.Data_Row:
	    bn_blob_len = len ( self.Data )
	    if ( self.ColName.endswith('Image') and ( 10 < bn_blob_len ) ):
	    #2do with header incorrect size
		#logging.info ( str ( self ) + " self.Data=" + str ( self.Data ) ) #bug4debug
		decode = base64.b64decode ( str ( self.Data ) )
		fd, tmpFile = mkstemp ()
		os.write ( fd, decode )
		os.close ( fd )
		tmpFile_png = tmpFile + str('.png')
		os.rename ( tmpFile, tmpFile_png )
		self.Grid.size_hint  = 1,None
		Widget               = bncSQLImageFull ()
		Widget.source        = tmpFile_png
		Widget.keep_ratio    = True
		Widget.allow_stretch = False
		#logging.debug ( str ( self ) + "Widget.texture_size=" + str ( Widget.texture_size ) )
		os.remove ( tmpFile_png )
	    elif 4 == bn_blob_len: #=NULL
		Widget      = bncSQLLabel ()
		Widget.text = str ( self.Data )
		Widget.texture_update ()
	    else:
		Widget      = bncSQLLabel ()
		Widget.text = "blob: size=" + str ( bn_blob_len )
		Widget.texture_update ()
	elif   'Button'    == self.Layout:
	    Widget               = bncSQLButton ()
	    Widget.text          = str ( self.Row[self.Data_Col] )
	    Widget.height        = self.Size_Hint_Min[1]
	elif "ImageButton" == self.Layout:
	    Widget               = bncSQLImageButton ()
	    Widget.keep_ratio    = True
	    Widget.allow_stretch = False
	    Widget.source        = self.Data
	elif 'TextInput' == self.Layout:
	    Widget               = bncSQLTextInput ()
	    Widget.text          = self.Data
	    Widget.height        = self.Size_Hint_Min[1]
	    #Widget.multiline = True #bug4debug, resize ok
	    #Widget.size_hint_min = (200,100) #ok
	    if self.Update: Widget.disabled = False
	    else:           Widget.disabled = True
	elif "CheckBox"  == self.Layout:
	    Widget               = bncSQLCheckBox()
	    try:
		Widget.active = bool ( int ( self.Row[self.Data_Col] ) )
	    except:
		pass
	    if self.Update: Widget.disabled = False
	    else:           Widget.disabled = True
	elif "DropDown" == self.Layout:
	    #logging.debug ( str ( self ) + " self.DropDowns=" + str ( self.DropDowns ) )
	    Widget          = bncSQLDropDown()
	    Widget.height   = self.Size_Hint_Min[1]
	    Widget.width    = 400 #bug2 auto like bncSQLLabel
	    Widget.text     = str ( self.Row[self.Data_Col] )
	    Widget.dropdown = DropDown()
	    if not self.DropDowns: self.DropDowns = []
	    for self.DropDown in self.DropDowns:
		btn            = Button()
		btn.text       = str (self.DropDown)
		btn.size_hint_y= None
		btn.height     = self.Size_Hint_Min[1]
		btn.bind(on_release=lambda btn: Widget.dropdown.select(btn.text))
		Widget.dropdown.add_widget(btn)
	    Widget.bind(on_release=Widget.dropdown.open)
	    Widget.dropdown.bind(on_select=lambda instance, x: setattr(Widget, 'text', x)) #bind to Widget, Widget is the last Widget in table
	    if self.Update: Widget.disabled = False
	    else:           Widget.disabled = True
	else:
	    Widget            = bncSQLLabel ()
	    if None != self.Data: Widget.text = self.Data
	    #else:                Widget.text = "Grid=(" + str ( Grid_Col ) + "," + str ( Grid_Row ) + ")" + "Data=(" + str ( self.Data_Col ) + "," + str ( self.Data_Row ) + ")" #bug4debug
	    if "" == Widget.text: Widget.text = " " #else no size, 2do via Resize()
	    Widget.texture_update ()
	    if "bn_char" == self.Type: Widget.halign    = 'left'

	Widget.ColName  = self.ColName
	Widget.Data_Row = self.Data_Row

    #Color Font/Background
	if -1 == self.Data_Row: #Header
	    if ( self.Data_Col % 2 ):
		Widget.colorbg = self.Col_Colorbg
		Widget.color   = self.Col_Color
	    else:
		Widget.colorbg = self.Col_ColorbgOdd
		Widget.color   = self.Col_ColorOdd
	else:
	    if ( self.Data_Row % 2 ):
		Widget.colorbg = self.Row_Colorbg
		Widget.color   = self.Row_Color
	    else:
		Widget.colorbg = self.Row_ColorbgOdd
		Widget.color   = self.Row_ColorOdd
	if None != self.Colorbg: Widget.colorbg = self.Colorbg
	if "ImageButton" == self.Layout:
	    Widget.colorbg = hex2color ( '#FFFFFF' ) #no change
	    Widget.color   = hex2color ( '#FFFFFF' )

	if self.RowPostCallBack: self.RowPostCallBack ( self, Widget )

	if not self.Mirror: Widget.ColumnIndex = ( Grid_Col, Grid_Row )
	else:               Widget.ColumnIndex = ( Grid_Row, Grid_Col )
	#logging.debug ( str ( self ) + " add_widget ( " + str ( Widget ) + " )" )
	#logging.debug ( str ( self ) + " Widget.__name__=" + str ( type (Widget).__name__ ) )
	self.Grid.add_widget ( Widget )

    def ColumnResize(self):
	#logging.debug ( str ( self ) )
	#logging.debug ( str ( self ) + " Grid.cols=" + str ( self.Grid.cols  ) )
	#logging.debug ( str ( self ) + " Grid.rows=" + str ( self.Grid.rows  ) )
	Cols      = []
	Rows      = []
	for Index in range ( self.Grid.cols ): Cols += [25]
	for Index in range ( self.Grid.rows ): Rows += [25]
	for Index in reversed ( range ( len ( self.Grid.children ) ) ):
	    #logging.debug ( str ( self ) + " Index=" + str ( Index ) )
	    Widget = self.Grid.children[Index]
	    #logging.debug ( str ( self ) + " Widget=" + str ( Widget ) )
	    #logging.debug ( str ( self ) + " Widget.ColumnIndex=" + str ( Widget.ColumnIndex ) + " Widget.size=" + str ( Widget.size ) )
	    if        Widget.size[0] > Cols[ Widget.ColumnIndex[0] ]: Cols[ Widget.ColumnIndex[0] ] =        Widget.size[0]
	    if        Widget.size[1] > Rows[ Widget.ColumnIndex[1] ]: Rows[ Widget.ColumnIndex[1] ] =        Widget.size[1]
	    if self.Size_Hint_Min[0] > Cols[ Widget.ColumnIndex[0] ]: Cols[ Widget.ColumnIndex[0] ] = self.Size_Hint_Min[0]
	    if self.Size_Hint_Min[1] > Rows[ Widget.ColumnIndex[1] ]: Rows[ Widget.ColumnIndex[1] ] = self.Size_Hint_Min[1]
	#logging.debug ( str ( self ) + " Cols=" + str ( Cols ) + " Rows=" + str ( Rows ) )
	for Index in reversed ( range ( len ( self.Grid.children ) ) ):
	    Widget = self.Grid.children[Index]
	    #logging.debug ( str ( self ) + " Widget.ColumnIndex=" + str ( Widget.ColumnIndex ) + " Widget.size=" + str ( Widget.size ) )
	    Widget.size = ( Cols[ Widget.ColumnIndex[0] ], Rows[ Widget.ColumnIndex[1] ] )

    def ColumnGet (self, Name):
	#logging.debug ( str ( self ) + " Name=" + str ( Name ) )
	try:
	    for Index in range ( self.ColCnt ):
		#logging.debug ( str ( self ) + " Name=" + str ( self.Cols[Index] ) )
		if Name == self.Cols[Index]:
		    return self.Rows[self.Data_Row][Index]
	    return None
	except:
	    return None


class bncSQLTableKivy(ScrollView, bncSQLTable, bncSQLColumn):
    Grid = None

    def __init__(self, **kwargs):
	Builder.load_string (  bncSQLTableKivy_kv  )
	#uilder.load_file   ( 'bncSQLTableKivy.kv' )
	super(bncSQLTableKivy, self).__init__(**kwargs)
	logging.debug ( str ( self ) )
	self.bind ( parent=self.ParentChange ) #self.__del__ trigger
	self.Close()
	#template bncSQLTable.__init__(self) #no __init__ via inherit class bncSQLTable

    def ParentChange(self, arg1, arg2): #self.__del__ trigger
	logging.debug ( str ( self ) + " arg1=" + str ( arg1 ) + " arg2=" + str ( arg2 ) )
	logging.debug ( str ( self ) + " parent=" + str ( self.parent ) )
	if self.parent:
	    pass
	else:
	    self.Close()
	#template bncSQLTable.__del__(self) #no __del__ via inherit class bncSQLTable

    def Close(self):
	logging.debug ( str ( self ) )
	bncSQLTable.Close(self)
	self.clear_widgets()
	self.Size_Hint_Min     = (5 * dp(1),5 * dp(1)) #(100,33) #2do ??? 33 4 input
	self.HeaderShow        = 1
	self.Insert            = 0
	self.DeletePos         = None
	self.EditPos           = None
	self.Colorbg           = hex2color ( '#101010' )
	self.Grid              = None
	self.Grid_Colorbg      = hex2color ( '#11D5EB' )
	self.Grid_Spacing      = (1,0)
	self.Mirror            = 0
	self.Col_Colorbg       = hex2color ( '#798984' )
	self.Col_Color         = hex2color ( '#101010' )
	self.Col_ColorbgOdd    = hex2color ( '#798984' )
	self.Col_ColorOdd      = hex2color ( '#101010' )
	self.Row_Colorbg       = hex2color ( '#202020' )
	self.Row_Color         = hex2color ( '#11D5EB' )
	self.Row_ColorbgOdd    = hex2color ( '#101010' )
	self.Row_ColorOdd      = hex2color ( '#11D5EB' )

    def SetGridCols(self, Cnt):
	if self.Mirror:
	    self.Grid.rows += int ( Cnt )
	else:
	    self.Grid.cols += int ( Cnt )

    def SetGridRows(self, Cnt):
	if self.Mirror:
	    self.Grid.cols += int ( Cnt )
	else:
	    self.Grid.rows += int ( Cnt )

    def Draw(self):
	logging.debug ( str ( self ) )
	#2do myPopup.dismiss()
	self.QueryRun()
	if ( self.Error != '' ): return self.ErrorDraw()
	logging.debug ( str ( self ) + " ColCnt=" + str ( self.ColCnt ) )
	logging.debug ( str ( self ) + " RowCnt=" + str ( self.RowCnt ) )
	#logging.debug ( str ( self ) + " Cols  =" + str ( self.Cols   ) ) #bug4debug
	#logging.debug ( str ( self ) + " Rows  =" + str ( self.Rows   ) ) #bug4debug
	if self.Grid: return
    #self = ScrollView
	self.colorbg          = self.Colorbg
    #self.Grid
	self.Grid             = bncSQLTableKivyGrid()
	self.Grid.colorbg     = self.Grid_Colorbg
	self.Grid.spacing     = self.Grid_Spacing
	self.Grid.size_hint_x = None #2do in .kv
	self.Grid.size_hint_y = None
	self.Grid.bind(minimum_height=self.Grid.setter('height'))
	self.Grid.bind(minimum_width =self.Grid.setter('width' ))
	self.Grid.rows = 0
	self.Grid.cols = 0
	self.SetGridCols ( self.ColCnt )
	self.SetGridRows ( self.RowCnt )
	if         self.HeaderShow: self.SetGridRows ( 1 )
	if None != self.DeletePos:  self.SetGridCols ( 1 )
	if None != self.EditPos:    self.SetGridCols ( 1 )
	if         self.Insert:     self.SetGridRows ( 1 )
	#logging.debug ( str ( self ) + " Grid.cols=" + str ( self.Grid.cols ) )
	#logging.debug ( str ( self ) + " Grid.rows=" + str ( self.Grid.rows ) )
	for Index in range ( self.Grid.cols * self.Grid.rows ):
	    #logging.debug ( str ( self ) + " Index=" + str ( Index ) )
	    self.SetColumn ( Index )
	self.ColumnResize ()
	self.add_widget ( self.Grid )
	#logging.debug ( str ( self ) + " Grid=" + str ( self.Grid ) )

    def ErrorDraw(self):
	logging.error ( str ( self ) + " Error=" + str ( self.Error ) )
	self.clear_widgets()
	lb = Label (
	    text   = "Error: " + self.Error,
	    color  = (1,0,0,1),
	    markup = True,
	)
	lb.bind(size=lb.setter('text_size'))
	self.add_widget ( lb )
	self.height += lb.height
