#Copyright 2017-2018 blacknoise.at
#
#   You may use this file WITHOUT CHANGES according to Apache License, Version 2.0.
#   Modifications of this file is NOT allowed without prior written permission.
#   For written permission, please contact us via http://www.blacknoise.at/?Contact
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#
import os
import sys
import imp
import json
import logging

try:
    from libbnplugin_py import *
except:
    logging.error ( "libbnplugin_py not fount !" )


class bnplugin_py_importer(object):

    def __init__(self, modules):
	pass

    def find_module(self, fullname, path):
	logging.debug ( "fullname=" + str ( fullname ) + " path=" + str ( path ) )
	bnplugin_py_find_module_msg = bnplugin_py_find_module ( fullname )
	if "OK" == bnplugin_py_find_module_msg:
	    logging.info ( "return self" )
	    return self
	logging.debug ( "no return" )

    def load_module(self, fullname):
	logging.debug ( "fullname=" + str ( fullname ) )
	bnplugin_py_load_module_msg, bnplugin_py_load_module_error = bnplugin_py_load_module ( fullname )
	logging.debug ( "bnplugin_py_load_module_msg  =~" + str ( bnplugin_py_load_module_msg   ) + "~" )
	logging.debug ( "bnplugin_py_load_module_error=~" + str ( bnplugin_py_load_module_error ) + "~" )
	if "" != bnplugin_py_load_module_msg:
	    new_module = imp.load_compiled( fullname, bnplugin_py_load_module_msg )
	    os.remove ( bnplugin_py_load_module_msg )
	    logging.info ( "return new_module=" + str ( new_module ) )
	    return new_module
	logging.debug ( "no return" )


class bnplugin_py_importer_api1(object):

    def __init__(self, modules):
	pass

    def find_module(self, fullname, path):
	logging.info ( "fullname=" + str ( fullname ) + " path=" + str ( path ) )
	PathName = os.path.join ( str ( sys.path[0] ), str ( fullname ) + ".pyc" )
	if os.path.isfile ( PathName ):
	    #logging.info ( "return self" )
	    return self
	#logging.info ( "no return" )

    def load_module(self, fullname):
	logging.info ( "fullname=" + str ( fullname ) )
	PathName = os.path.join ( str ( sys.path[0] ), str ( fullname ) + ".pyc" )
	if os.path.isfile ( PathName ):
	    new_module = imp.load_compiled( fullname, PathName )
	    #logging.info ( "return new_module=" + str ( new_module ) )
	    return new_module
	#logging.info ( "no return" )


class bnplugin():
    TmpDir = '.'
    def __init__(self, **kwargs):
	logging.debug ( str ( self ) )
	#2do2 sys.meta_path.append ( bnplugin_py_importer ( "" ) ) #real-time load modules via bnplugin
	sys.meta_path.append ( bnplugin_py_importer_api1 ( "" ) )
	self.API_Version = None
	self.ClientKey   = None
	self.MTime       = None
	pass

    def Load(self, Plugin):
	if ( "" == self.TmpDir ): self.TmpDir = '/tmp'
	try:
	    os.makedirs ( self.Expand )
	except:
	    pass
	TriggerFile = os.path.join ( self.Expand, "app.info" )
	if not os.path.isfile ( TriggerFile ):
	    logging.info  ( str ( self ) + " Plugin="  + str ( Plugin ) + " TmpDir=" + str ( self.TmpDir ) + " Expand=" + str ( self.Expand ) )
	    bnplugin_py_load_msg, self.API_Version, self.ClientKey, self.MTime = bnplugin_py_load ( Plugin, str ( self.TmpDir ), str ( self.Expand ) )
	    logging.debug ( str ( self ) + " bnplugin_py_load_msg=" + str ( bnplugin_py_load_msg ) )
	    logging.debug ( str ( self ) + " API_Version =" + str ( self.API_Version  ) )
	    logging.debug ( str ( self ) + " ClientKey   =" + str ( self.ClientKey    ) )
	    logging.debug ( str ( self ) + " MTime       =" + str ( self.MTime        ) )
	    app_info = {
		'ClientKey':   str ( self.ClientKey   ),
		'API_Version': str ( self.API_Version ),
		'MTime':       str ( self.MTime       ),
	    }
	    logging.info ( str ( self ) + " app_info       =" + str ( app_info       ) )
	    if "OK" != bnplugin_py_load_msg:
		logging.error ( str ( self ) + " bnplugin_py_load_msg=" + str ( bnplugin_py_load_msg ) )
		raise ImportError ( Plugin )
	    try:
		with open ( TriggerFile, 'w' ) as f: json.dump ( app_info, f )
		f.close ();
	    except:
		logging.error ( str ( self ) + " write TriggerFile=" + str ( TriggerFile ) )
	else:
	    app_info = {}
	    try:
		with open ( TriggerFile ) as f: app_info = json.load ( f )
		f.close ();
	    except:
		logging.error ( str ( self ) + " read TriggerFile=" + str ( TriggerFile ) )
	    #logging.debug ( str ( self ) + " app_info       =" + str ( app_info       ) )
	    self.ClientKey   = app_info[ 'ClientKey'   ]
	    self.API_Version = app_info[ 'API_Version' ]
	    self.MTime       = app_info[ 'MTime'       ]
	    #logging.debug ( str ( self ) + " ClientKey   =" + str ( self.ClientKey    ) )
	logging.info ( str ( self ) + " ClientKey   =" + str ( self.ClientKey    ) )

    def Close(self):
	logging.info ( str ( self ) )
	self.API_Version = None
	self.ClientKey   = None
	self.MTime       = None
	bnplugin_py_close ()
