#Copyright 2017-2018 blacknoise.at
#
#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at
#
#       http://www.apache.org/licenses/LICENSE-2.0
#
#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.
#
import re
import os
import sys
#for sys_path in sys.path: print ( "sys_path=" + str ( sys_path ) ) #bug4debug
import Version

#KIVY_HOME
if "linux-x86_64"          == Version.PLATFORM:
    os.environ['KIVY_HOME'] = os.environ['HOME'] + "/bncsql"
if "windows-x86_64"        == Version.PLATFORM:
    os.environ['KIVY_HOME'] = os.environ['APPDATA'] + "/bncsql"
if "osx-x86_64" == Version.PLATFORM:
    os.environ['KIVY_HOME'] = os.environ['HOME'] + "/bncsql"
if "arm-linux-androideabi" == Version.PLATFORM:
    os.environ['KIVY_HOME'] = os.environ['EXTERNAL_STORAGE'] + "/bncsql"
if "ios-arm64"              == Version.PLATFORM or "ios-armv7"              == Version.PLATFORM:
    os.environ['KIVY_HOME'] = os.environ['HOME'] + '/Library/Documents' + "/bncsql" #bug2 KIVY_HOME is in a sandbox, lost @ reinstall !!!
    try:
	os.makedirs ( os.environ['KIVY_HOME'] )
    except:
	pass
#KIVY_HOME done

from   kivy.utils             import platform
from   kivy.config            import Config
from   kivy.core.window       import Window
from   kivy.metrics           import dp, sp

from   bnlog                  import *
import atexit
import shutil
import logging

from   bncSQLLib              import *
from   bnplugin               import *


if "ios-arm64"              == Version.PLATFORM or "ios-armv7"              == Version.PLATFORM:
    Config.read ( str ( os.environ['KIVY_HOME'] ) + "/config.ini" )
    #print "config...=" + str ( Config.get ( 'graphics', 'width'  ) ) #bug4debug
    Config.write()
    #dirxList = str ( os.environ['KIVY_HOME'] ) #bug4debug
    #print ( "dirxList(" + dirxList + ")=" + str ( os.listdir ( dirxList ) ) + "=" ) #bug4debug


def MainLoad():
    logging.info ( "MainLoad" )

    Version.mainLogLevel        = Config.get ( 'bncsql', 'LogLevel'   )
    Version.mainBackground      = Config.get ( 'bncsql', 'Background' )
    Version.mainZoom            = dp(1) * int ( Config.get ( 'bncsql', 'ZoomPercent' ) ) / 100
    if str ( Version.mainPlatform ) == 'android': Version.mainZoom *= 1.5
    if str ( Version.mainPlatform ) == 'ios':     Version.mainZoom *= 1.5

    #Config.set ( 'bncsql', 'Load', '' ) #bug4debug
    #Config.write() #bug4debug

    try:
	Version.mainLoad = str ( Config.get ( 'bncsql', 'load' ) )
    except:
	Version.mainLoad = None
	pass
    Version.mainLoadAPI_Version = ''
    Version.mainLoadClientKey   = ''
    Version.mainLoadMTime       = ''
    Version.mainLoadExpand      = ''

    #Version.mainLoad = "Demo_Solar.bncbin"  #bug4debug
    #Version.mainLoad = "dummy.bncbin" #bug4debug

    Version.mainPlugin.Close ()

    for sys_path in sys.path:
	if sys_path.endswith ( '.bncbin' ): sys.path.remove ( sys_path )

    if Version.mainLoad.endswith ( '.bncbin' ):
	logging.info ( "Version.mainLoad=" + str ( Version.mainLoad ) )
	if Version.mainLoad:
	    try:
		logging.info ( "Version.mainPlugin=" + str ( Version.mainPlugin ) )
		Version.mainPlugin.TmpDir   = Version.mainTemp
		Version.mainLoadExpand      = os.path.join ( Version.mainTemp, Version.mainLoad )
		Version.mainPlugin.Expand   = Version.mainLoadExpand
		Version.mainPlugin.Load     ( os.path.join ( Version.mainHome, Version.mainLoad ) )
		Version.mainLoadAPI_Version = Version.mainPlugin.API_Version
		Version.mainLoadClientKey   = re.sub ( r'.crt$', '', Version.mainPlugin.ClientKey )
		Version.mainLoadMTime       = Version.mainPlugin.MTime
		sys.path.insert (0, Version.mainLoadExpand )
	    except:
		logging.error ( "App " + str ( Version.mainLoad ) + " not found !" )
		AppMsg2     = AppMsg()
		AppMsg2.Msg =   "App " + str ( Version.mainLoad ) + " not found !\nEXIT BNCSQL"
		AppMsg2.run()
		Config.set ( 'bncsql', 'Load', '' )
		Config.write()
		exit()

    #for sys_module in sys.modules: logging.info ( "sys_module=" + str ( sys_module ) ) #bug4debug
    #for sys_path in sys.path: logging.info ( "sys_path=" + str ( sys_path ) ) #bug4debug

#Load and Ini MainApp here !!!, else wrong MainScreen
    from MainApp import *
    if not Version.mainApp: Version.mainApp = MainApp ()
    logging.info ( "Version.mainApp=" + str ( Version.mainApp ) )

    ConfigPositionWrite( -1, -1, Window.left - 4, Window.top - 24 )
    #if str ( Version.mainPlatform ) == 'linux': from bninfo import bninfo; bninfo().http_server_thread ( "MainApp", Version.mainApp ) #bug4debug

    '''
    #Version.mainApp.run () #bug4debug
    '''
    try:
	Version.mainApp.run ()
    except:
	AppMsgErr     = AppMsg()
	AppMsgErr.Msg = "mainApp.run () " + str ( Version.mainLoad ) + " !\nEXIT BNCSQL"
	AppMsgErr.run()
	Config.set ( 'bncsql', 'Load', '' )
	Config.write()
	exit()


def ConfigPositionWrite ( Window_width, Window_height, Window_left, Window_top ):
    logging.info ( "Window_width  =" + str ( Window_width  ) )
    logging.info ( "Window_height =" + str ( Window_height ) )
    logging.info ( "Window_left   =" + str ( Window_left   ) )
    logging.info ( "Window_top    =" + str ( Window_top    ) )
    if "linux-x86_64" != Version.PLATFORM: return
    Config_write  = 0
    Config_width  = int ( Config.get ( 'graphics', 'width'  ) )
    Config_height = int ( Config.get ( 'graphics', 'height' ) )
    Config_left   = int ( Config.get ( 'graphics', 'left'   ) )
    Config_top    = int ( Config.get ( 'graphics', 'top'    ) )
    logging.info ( "Config_width  =" + str ( Config_width  ) )
    logging.info ( "Config_height =" + str ( Config_height ) )
    logging.info ( "Config_left   =" + str ( Config_left   ) )
    logging.info ( "Config_top    =" + str ( Config_top    ) )

    if 0 <= Window_width and Window_width != Config_width:
	Config.set ( 'graphics', 'width', str ( Window_width   ) )
	Config_write = 1
    if 0 <= Window_height and Window_height != Config_height:
	Config.set ( 'graphics', 'height', str ( Window_height ) )
	Config_write = 1
    if 0 <= Window_left <= 2000 and Window_left != Config_left:
	Config.set ( 'graphics', 'left'  , str ( Window_left   ) )
	Config_write = 1
    if 0 <= Window_top <= 2000 and Window_top != Config_top:
	Config.set ( 'graphics', 'top'   , str ( Window_top    ) )
	Config_write = 1

    if Config_write:
	logging.info ( "Config_write" )
	Config.write()


def MainExit():
    logging.debug ( "MainExit" )
    ConfigPositionWrite ( Window.width, Window.height, -1, -1 )
    #logging.info ( str ( "self" )  + " Window.top=" + str ( Window.top ) ) #bug4debug
    Version.mainReload = 0
    return Version.mainReload


def MainStart():
    logging.info ( "main start PACKAGE_VERSION=" + str ( Version.PACKAGE_VERSION ) )
    atexit.register ( MainExit )

    #mainPathFile = os.path.abspath ( __file__ )             #bug4debug
    #logging.info ( "mainPathFile=" + str ( mainPathFile ) ) #bug4debug

    Version.mainPlatform = platform
    logging.info ( "mainPlatform=" + str ( Version.mainPlatform ) )

    Version.mainPwd = str ( os.getcwd () )
    logging.info ( "mainPwd=" + str ( Version.mainPwd ) )

    if str ( Version.mainPlatform ) == 'linux':
	Version.mainHome = os.environ['HOME']
    if str ( Version.mainPlatform ) == 'ios':
	Version.mainHome = os.environ['HOME']
	Version.mainHome = Version.mainHome + '/Library/Documents'
    if str ( Version.mainPlatform ) == 'win':
	Version.mainHome = os.environ['APPDATA']
    if str ( Version.mainPlatform ) == 'android':
	Version.mainHome = os.environ['EXTERNAL_STORAGE']
	#ersion.mainHome = os.environ['ANDROID_APP_PATH'] #2do new check it ???
    if str ( Version.mainPlatform ) == 'macosx':
	Version.mainHome = os.environ['HOME']

    Version.mainHome = os.path.join ( Version.mainHome, str ( 'bncsql' ) )
    #ersion.mainHome = mainPathFile #'/dev/null' #bug4debug
    #ersion.mainHome = '/usr/dummy'              #bug4debug
    logging.info ( "mainHome=" + str ( Version.mainHome ) )
    if not os.path.exists ( Version.mainHome ): # 2do also true if Version.mainHome is a file
	try:
	    os.makedirs ( Version.mainHome )
	except:
	    logging.error ( "Error: os.makedirs (mainHome=" + str ( Version.mainHome ) + ") !" )
	    AppMsgErr     = AppMsg()
	    AppMsgErr.Msg = "Error: os.makedirs (mainHome=" + str ( Version.mainHome ) + ") !"
	    AppMsgErr.run()
	    exit()

    Version.mainTemp = os.path.join ( Version.mainHome, str ( 'tmp' ) )
    #ersion.mainTemp = '/dev/null' #bug4debug
    logging.info ( "mainTemp=" + str ( Version.mainTemp ) )
    if not os.path.exists ( Version.mainTemp ):
	try:
	    os.makedirs ( Version.mainTemp )
	except:
	    logging.error ( "Error: os.makedirs (mainTemp=" + str ( Version.mainTemp ) + ") !" )
	    AppMsgErr     = AppMsg()
	    AppMsgErr.Msg = "Error: os.makedirs (mainTemp=" + str ( Version.mainTemp ) + ") !"
	    AppMsgErr.run()
	    exit()

    Version.mainLibPath = str ( Version.mainPwd )
    #ersion.mainLibPath = "/tmp/dummy/mainLibPath" #bug4debug
    if str ( Version.mainPlatform ) == 'android':
	try:
	    Version.mainLibPath = os.environ['PYTHONHOME'] #=ANDROID_PRIVATE
	    #Version.mainLibPath = Version.mainLibPath.replace ( '/files'    , '/lib' ) kivy-1.9.0 p4a old
	    Version.mainLibPath = Version.mainLibPath.replace ( '/files/app', '/lib' ) #kivy-1.10 p4a
	    #ersion.mainLibPath = '/data/local/tmp' #also OK @ android
	except:
	    pass

    #logging.info ( "mainLibPath=" + str ( Version.mainLibPath ) )
    #for LibFile in os.listdir ( Version.mainLibPath ): print ( "LibFile=" + str ( LibFile ) ) #bug4debug

    if "linux-x86_64" == Version.PLATFORM:
	#2do or "osx-x86_64" == Version.PLATFORM:
	Config_left = int ( Config.get ( 'graphics', 'left' ) )
	Config_top  = int ( Config.get ( 'graphics', 'top'  ) )
	logging.info ( "Config_left=" + str ( Config_left   ) )
	logging.info ( "Config_top =" + str ( Config_top    ) )
	if 0 <= Config_left <= 2000: Window.left = Config_left
	if 0 <= Config_top  <= 2000: Window.top  = Config_top

    try:
	Config.get ( 'bncsql', 'Load' )
    except:
    #ini new bncsql
	Config.adddefaultsection ( 'bncsql' )
	Config.set ( 'bncsql', 'Load', 'Demo-SQL.bncsql' )
	Config.write()
	for defFile in [ 'Demo_Solar.bncbin', 'Demo-SQL.bncsql', 'testbncsql.blacknoise.at.key', 'testbncsql.blacknoise.at.crt' ]:
	    srcFile = os.path.join( Version.mainPwd , defFile )
	    dstFile = os.path.join( Version.mainHome, defFile )
	    if not os.path.exists ( dstFile ):
		logging.info ( "shutil.copy2 ( " + srcFile + ", " + dstFile + " )" )
		try:
		    shutil.copy2 ( srcFile, dstFile )
		except:
		    logging.error ( "shutil.copy2 ( " + srcFile + ", " + dstFile + " )" )
		    pass

    try:
	Config.get ( 'bncsql', 'Header' )
    except:
	Config.set ( 'bncsql', 'Header', '1' )
	Config.write()
    try:
	Config.get ( 'bncsql', 'Profiles' )
    except:
	Config.set ( 'bncsql', 'Profiles', '1' )
	Config.write()
    try:
	Config.get ( 'bncsql', 'QueryPrompt' )
    except:
	Config.set ( 'bncsql', 'QueryPrompt', '1' )
	Config.write()
    try:
	Config.get ( 'bncsql', 'Tables' )
    except:
	Config.set ( 'bncsql', 'Tables', '2' )
	Config.write()
    try:
	Config.get ( 'bncsql', 'Download' )
    except:
	Config.set ( 'bncsql', 'Download', '0' )
	Config.write()
    try:
	Config.get ( 'bncsql', 'LogLevel' )
    except:
	Config.set ( 'bncsql', 'LogLevel', '0' )
	Config.write()
    try:
	Config.get ( 'bncsql', 'Background' )
    except:
	Config.set ( 'bncsql', 'Background', 'background-pexels-photo-207130.png' )
	Config.write()
    try:
	Config.get ( 'bncsql', 'ZoomPercent' )
    except:
	Config.set ( 'bncsql', 'ZoomPercent', '100' )
	Config.write()

    #Config.set ( 'kivy', 'keyboard_mode', 'dock'   ) #bug4debug
    #Config.set ( 'kivy', 'keyboard_mode', 'system' ) #bug4debug
    #Config.write()                                   #bug4debug

    #Config.set ( 'kivy', 'log_name', 'kivy.txt'    ) #bug4debug
    #Config.write()                                   #bug4debug

    #Config.set ( 'kivy', 'log_level', 'debug'      ) #bug4debug
    #Config.set ( 'bncsql', 'Load', ''              ) #bug4debug
    #Config.write()                                   #bug4debug

    #logging.info ( "Window.softinput_mode=" + str ( Window.softinput_mode ) )
    if   str ( Version.mainPlatform ) == 'macosx': #kivy-1.9.0
	Window.softinput_mode = ""
    elif str ( Version.mainPlatform ) == 'win':    #kivy-1.9.0
	Window.softinput_mode = ""
    else: #kivy-1.10 Linux, Android, iOS
	Window.softinput_mode = "below_target"
    #logging.info ( "Window.softinput_mode=" + str ( Window.softinput_mode ) )

    Version.mainPlugin = bnplugin ()

    Version.mainReload = 1
    while 1 == Version.mainReload:
	Version.mainReload = 0
	MainLoad()
	logging.info ( "mainReload=" + str ( Version.mainReload ) )

    logging.info ( "main exit" )

if __name__ == '__main__':
    MainStart()
